'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('UserPolicies', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      policyId: {
        type: Sequelize.INTEGER,
        references: {
					model: 'Policies',
					key: 'id'
				}
      },
      userId: {
        type: Sequelize.INTEGER,
        // references: {
				// 	model: 'Employees',
				// 	key: 'id'
				// }
      },
      memberId: {
        type: Sequelize.INTEGER,
        // references: {
				// 	model: 'Employees',
				// 	key: 'id'
				// }
      },
      type: { 
        type: Sequelize.STRING,
				defaultValue: 'employee'
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull:true,
        type: Sequelize.DATE
      },
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('UserPolicies');
  }
};