'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn(
        'Campaigns',
        'quizCount',{
          type: Sequelize.INTEGER
        }
      ),
      queryInterface.changeColumn(
        'Campaigns',
        'courseCount',{
          type: Sequelize.INTEGER,
          allowNull: true,
        }
      )
    ])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.removeColumn(
        'Campaigns',
        'quizCount'
        )
    ])
  }
};
