'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn(
        'MemberCourses',
        'quizTimer',{
          type: Sequelize.STRING,
          allowNull: true,
        }
      )
    ])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
        queryInterface.removeColumn(
        'MemberCourses',
        'quizTimer'
        )
      ])
  }
};
