var limit = 10;
var activityType = 'all';
var activityDate = 'all';

var loadMore = function() {
    limit = limit + 10;
    load();
}

var chooseCategory = function(type)  {
    if (type != '') activityType = type;
    else activityType = 'all';
    limit = 10;
    load();
}

var chooseDate = function(d)  {
    activityDate = d;
    limit = 10;
    load();
}

var loadActivities = function(data)  {
    if (data.type == "campaign") 
        var icon = 'icons';
    if (data.type == "course") 
        var icon = 'basic';
    if (data.type == "department")
        var icon = 'user';
    if (data.type == "quiz")
        var icon = 'pages';
    if (data.type == "skill")
        var icon = 'maps';
    var text = data.text;
    var textdata = text.split("by");
    $('#activityDataWrap').append('<div class="activity_list_wrap"> <div class="activity_descrption"> <div class="icon_show"> <img src="/static/images/svg-icon/'+icon+'.svg" class="img-fluid img_icon_act" alt="widgets"> </div> <div class="acti_data_wrap"> <h5 class="list_name">' + capitalizeFirstLetter(textdata[0]) + 'by <span class="name_acti">' + (data.User ? data.User.firstName+' '+(data.User.lastName ? data.User.lastName : ''): 'NA') + '</span></h5> <p class="name_desc">'+capitalizeFirstLetter((data.type == 'quiz' ? 'assessment' : data.type))+'</p> </div> </div> <div class="time_acti_wrap"> <p>' + AM_PM(data.createdAt) + ' | ' + format(data.createdAt) + ' </p> </div> </div> ');
}

var validateAll = function () {
    var data = new Object();
    if (activityType != "")
        data.type = activityType;
    if (activityDate != "")
        data.activityDate = activityDate;
    data.limit = limit;
    return data;
}

var load = function()  {
    var data = validateAll();
    api.home.activityLog(data, function (success) {
        if (limit == 10)
            $('#activityDataWrap').html('');
        if (success && success.data && success.data.length) {
            $('.loader_with').show();
            $('.heading_acti').show();
            success.data.forEach(function (element) {
                loadActivities(element);
            });
            $(".activity_list_wrap").slice(0, limit).css({ "display": "flex" });
            if(success.data.length < 10)
                $('.loader_with').hide();
        } else {
            if (limit > 10) {
                $('.loader_with').hide();
            } else {
                $('.loader_with').hide();
                $('.heading_acti').hide();
                $('#activityDataWrap').html('<h4>No Activities Found</h4>');
            }
        }
    });
}

$(document).ready(function () {
    load();
    $('#categorySelect').on('click', 'li', function () {
        $('#categorySelect .active').removeClass('active');
        $(this).addClass('active');
    });
    $('#selectDate').on('click', 'li', function () {
        $('#selectDate .active').removeClass('active');
        $(this).addClass('active');
    });
});