import ActiveDirectory from 'activedirectory';

var groupName = 'Tech';
//   ad.findUser(opts, config.username, function(err, user) {
//     if (err) {
//       console.log('ERROR: ' +JSON.stringify(err));
//       return;
//     }

//     if (! user) console.log('User: ' + username + ' not found.');
//     else console.log(JSON.stringify(user));
//   });
var query = 'cn=*';
//   ad.findUsers(query, true, function(err, users) {
//     if (err) {
//       console.log('ERROR: ' +JSON.stringify(err));
//       return;
//     }
   
//     if ((! users) || (users.length == 0)) console.log('No users found.');
//     else {
//       console.log('findUsers: '+JSON.stringify(users));
//     }
//   });
// ad.groupExists(opts, groupName, function(err, exists) {
//     if (err) {
//       console.log('ERROR: ' +JSON.stringify(err));
//       return;
//     }
   
//     console.log(groupName + ' exists: ' + exists);
//   });
    //     var groupname = '';
    //     ad.getGroupMembershipForUser(opts, data.username, function(err, groups) {
    //         if (err) {
    //             console.log('ERROR: ' +JSON.stringify(err));
    //             return;
    //         }
    //         if (! groups) return done(null, false);
    //         else {
    //             groups.forEach(function (group) {
    //                 if (config.group.indexOf(group.cn)>=0)
    //                 groupname=group.cn;
    //                 // console.log(group.cn);
    //             });
    //         }

    //        console.log('return',groupname); // output is 'return' !!!
    //        if (groupname) return done(null, {
    //          username: data.username
    //        })

    //    });
    // ad.findGroups(query, function(err, groups) {
    //     if (err) {
    //         console.log('ERROR: ' +JSON.stringify(err));
    //         return;
    //     }
       
    //     if ((! groups) || (groups.length == 0)) console.log('No groups found.');
    //     else {
    //         console.log('findGroups: '+JSON.stringify(groups));
    //     }
    //   });
    
//   ad.getUsersForGroup(opts, groupName, function(err, users) {
//     if (err) {
//       console.log('ERROR: ' +JSON.stringify(err));
//       return;
//     }
   
//     if (! users) console.log('Group: ' + groupName + ' not found.');
//     else {
//         console.log(JSON.stringify(users));
//     }
//   });
// ad.getGroupMembershipForGroup(opts, groupName, function(err, groups) {
//     if (err) {
//       console.log('ERROR: ' +JSON.stringify(err));
//       return;
//     }
   
//     if (! groups) console.log('Group: ' + groupName + ' not found.');
//     else console.log(JSON.stringify(groups));
//   });
// ad.getGroupMembershipForUser(opts, data.username, function(err, groups) {
//     if (err) {
//       console.log('ERROR: ' +JSON.stringify(err));
//       return;
//     }
   
//     if (! groups) console.log('User: ' + sAMAccountName + ' not found.');
//     else console.log(JSON.stringify(groups));
//   });



// var opts = {
//     // scope: 'sub',
//     // filter: 'objectClass=Group',
//     // includeMembership: [ 'user' ],
// };


export default {
    connectAD: function(data){
        return new Promise((resolve, reject) => {
            var baseDomain = data.baseDN.split(".");
            var config = { 
                url: (data.ssl == 'http' ? 'ldap://'+data.url: 'ldaps://'+data.url),
                baseDN: 'dc='+baseDomain[0]+',dc='+baseDomain[1],
                username: data.username,
                password: data.password
            }
            var ad = new ActiveDirectory(config);
            ad.authenticate(config.username, config.password, function(err, auth) {
                if(err){
                    console.log('ERROR: '+JSON.stringify(err));
                    resolve(JSON.stringify(err));
                }
                if(auth){
                    console.log('Authenticated!');
                    resolve(auth);
                }
            });
        })
    },

    getGroups: function(data){
        return new Promise((resolve, reject) => {
            var config = { 
                url: data.url,
                baseDN: data.baseDN,
                username: data.username,
                password: data.password
            }
            var ad = new ActiveDirectory(config);
            ad.authenticate(config.username, config.password, function(err, auth) {
                if(err){
                    console.log('ERROR: '+JSON.stringify(err));
                    resolve(JSON.stringify(err));
                }
                if(auth){
                    console.log('Authenticated!');
                    var query = (data.search && data.search != '' ? 'cn=*'+data.search+'*' : 'cn=*');
                    ad.findGroups(query, function(err, groups) {
                        if (err) {
                            console.log('ERROR: ' +JSON.stringify(err));
                            return;
                        }
                        if ((! groups) || (groups.length == 0)) resolve(false);
                        else  resolve(JSON.stringify(groups))
                    });
                }
            });
        })
    },

    getUsers: function(data){
        return new Promise((resolve, reject) => {
            var config = { 
                url: data.url,
                baseDN: data.baseDN,
                username: data.username,
                password: data.password
            }
            var ad = new ActiveDirectory(config);
            ad.authenticate(config.username, config.password, function(err, auth) {
                if(err){
                    console.log('ERROR: '+JSON.stringify(err));
                    resolve(JSON.stringify(err));
                }
                if(auth){
                    console.log('Authenticated!');
                    var query = (data.search && data.search != '' ? 'cn=*'+data.search+'*' : 'cn=*');
                    ad.findUsers(query, true, function(err, users) {
                        if (err) {
                          console.log('ERROR: ' +JSON.stringify(err));
                          return;
                        }
                        if ((! users) || (users.length == 0)) resolve(false);
                        else resolve(JSON.stringify(users))
                    });
                }
            });
        })
    },

    getUsersForGroups: function(data, groupName){
        return new Promise((resolve, reject) => {
            var baseDomain = data.baseDN.split(".");
            var config = { 
                url: (data.ssl == 'http' ? 'ldap://'+data.url: 'ldaps://'+data.url),
                baseDN: 'dc='+baseDomain[0]+',dc='+baseDomain[1],
                username: data.username,
                password: data.password
            }
            var ad = new ActiveDirectory(config);
            ad.getUsersForGroup(groupName, function(err, users) {
                if (err) {
                    console.log('ERROR: ' +JSON.stringify(err));
                    return;
                }
                if (!users) resolve(false);
                else{
                    console.log(JSON.stringify(users));
                    resolve(users);
                } 
            });
        });
    },
}

