'use strict';
module.exports = (sequelize, DataTypes) => {
  const CampaignGroup = sequelize.define('CampaignGroup', {
    campaignId: DataTypes.INTEGER,
    groupId: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,});
  CampaignGroup.associate = function(models) {
    models.CampaignGroup.belongsTo(models.Campaign, {foreignKey: 'campaignId'});
    models.CampaignGroup.belongsTo(models.Group, {foreignKey: 'groupId'});
  };
  return CampaignGroup;
};