'use strict';
module.exports = (sequelize, DataTypes) => {
  const policy = sequelize.define('Policy', {
    name: DataTypes.STRING,
    type: DataTypes.STRING,
    description: DataTypes.STRING,
    companyId: DataTypes.INTEGER,
    deletedAt: DataTypes.DATE
  }, {});
  policy.associate = function(models) {
		models.Policy.hasMany(models.PolicyAction, {foreignKey: 'policyId'});
		models.Policy.hasMany(models.UserPolicy, {foreignKey: 'policyId'});
    models.Policy.belongsTo(models.Company, {foreignKey: 'companyId'});
  };
  return policy;
};