'use strict';
module.exports = (sequelize, DataTypes) => {
  const QuizQuestionOption = sequelize.define('QuizQuestionOption', {
    quizQuestionId: DataTypes.INTEGER,
    title: DataTypes.TEXT,
    isCorrect: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  QuizQuestionOption.associate = function(models) {
  models.QuizQuestionOption.belongsTo(models.QuizQuestion, { foreignKey: 'quizQuestionId'});
  models.QuizQuestionOption.hasMany(models.QuizSecctionTracking, { foreignKey: 'answerId'});
  };
  return QuizQuestionOption;
};