'use strict';
module.exports = (sequelize, DataTypes) => {
  const QuizUserDetail = sequelize.define('QuizUserDetail', {
    quizId: DataTypes.INTEGER,
    sessionId: DataTypes.INTEGER,
    attempts: DataTypes.INTEGER,
    percent: DataTypes.DECIMAL,
    maxMarks:DataTypes.INTEGER,
    obtainedMarks:DataTypes.INTEGER,
  }, {
    timestamps: true,
    paranoid: true,
  });
  QuizUserDetail.associate = function(models) {
    models.QuizUserDetail.belongsTo(models.Quiz, { foreignKey: 'quizId'});
    models.QuizUserDetail.belongsTo(models.Session, { foreignKey: 'sessionId'});
  };
  return QuizUserDetail;
};