'use strict';
module.exports = (sequelize, DataTypes) => {
  const SessionEvent = sequelize.define('SessionEvent', {
    simulationId: DataTypes.INTEGER,
    sessionId: DataTypes.INTEGER,
    message: DataTypes.STRING,
    details: DataTypes.TEXT,
    metaData: DataTypes.TEXT
  }, {
    timestamps: true,
    paranoid: true,
  });
  SessionEvent.associate = function(models) {
    models.SessionEvent.belongsTo(models.Session, {foreignKey: 'sessionId'});
  };
  return SessionEvent;
};