'use strict';
module.exports = (sequelize, DataTypes) => {
  const Skill = sequelize.define('Skill', {
    name: DataTypes.STRING,
    parentId: DataTypes.INTEGER,
    companyId: DataTypes.INTEGER
    
  }, {
    timestamps: true,
    paranoid: true,
  });
  Skill.associate = function(models) {  
    models.Skill.hasMany(models.CourseSkill, { foreignKey: 'skillId'});
    models.Skill.hasMany(models.GroupSkill, { foreignKey: 'skillId'});
    models.Skill.hasMany(models.AssessmentSkill, { foreignKey: 'skillId'});
  };
  return Skill;
};