var sectionCount = 1;
var lectureCount = 1;
var type = '';
var duration = 0;
var thumbnail = "";
var sec_no = 1;
var lect_no = 1;
var setting = false;
var arr = [];
var courseStatus;
var dbSkills = [];
var vidImgSrc = '';
var uploadedFileName;
var courseType = "";



function clearCreateSkill() {
    $('#skillNewName').val('');
    revomeExistingSkill();
}


function validateNewSkill() {
    clearErrors();
    var data = new Object();
    if ($("input[name='skill']:checked").attr('id') != undefined) {
        var splitedData = $("input[name='skill']:checked").attr('id').split("-");
        data.parentId = splitedData[2];
    } else data.parentId = 0;
    data.name = $('#skillNewName').val();
    if (data.name.length == 0)
        addError('name', 'Skill name is required field!');
    hasError() && showErrors();
    return data;
}

function addNewSkill() {
    var data = validateNewSkill();
    !hasError() && data && api.skill.add(data, function(success) {
        if(success){
            clearCreateSkill();
            var skill = {
                id: success.diX342,
                parentId:success.gif$5ds,
                name: success.name
            }
            if($('#skills_append li:first').text() == "No Skill Found.")
                $('#skills_append').html('');
            appendSkills(skill);
            addExistingSkill(skill);
            if(!dataObj[success.gif$5ds])  dataObj[success.gif$5ds] = [];
            dataObj[success.gif$5ds].push(skill);
            finalArray = setSkillJson([], 'p', dataObj[0],  dataObj);
            loadJsTree(finalArray);
        }
        showSuccess('New Skill is successfully added.');
    });
}

function revomeExistingSkill() {
    $(".skill-radio").prop("checked", false);
    $('#exist-skill').html('<i class="fa fa-lg fa-tasks"></i> Select Skill</a></h3>');
}

function setExistingSkillName(name) {
    $('#exist-skill').html('').html('<i class="fa fa-lg fa-tasks"></i>  <span>' + name + '  <i class="feather icon-x" onclick="revomeExistingSkill()"></i></span>');
    var link = $("#accordian a");
    var closest_ul = link.closest("ul");
    var parallel_active_links = closest_ul.find(".active")
    closest_ul.find("ul").slideUp(function () {
        if (closest_ul.find("ul").length)
            parallel_active_links.removeClass("active");
    });
}

function addExistingSkill(skill) {
    if (skill.parentId == 0) {
        $('#existing-skill').append('<li id="existing-skill-' + skill.id + '"><a><input type="radio" id="radio-skill-' + skill.id + '" name="skill" class="skill-radio" onclick="setExistingSkillName(\'' + skill.name + '\')"> <label for="radio-skill-' + skill.id + '"> ' + skill.name + '</label></a></li>');
    } else {
        if (!$('#existing-skill').has('li').length)
            $('#existing-skill').append('<li id="existing-skill-' + skill.id + '"><a><input type="radio" id="radio-skill-' + skill.id + '" name="skill" class="skill-radio" onclick="setExistingSkillName(\'' + skill.name + '\')"> <albel for="radio-skill-' + skill.id + '"> ' + skill.name + '<label></a></li>');
        else {
            if (!$('#existing-skill-' + skill.parentId).has('ul').length)
                $('#existing-skill-' + skill.parentId).append('<ul></ul>');
            $('#existing-skill-' + skill.parentId + ' > ul').append('<li id="existing-skill-' + skill.id + '"><a><input type="radio"  id="radio-skill-' + skill.id + '" class="skill-radio" name="skill" onclick="setExistingSkillName(\'' + skill.name + '\')"> <label for="radio-skill-' + skill.id + '">  ' + skill.name + '</label></a></li>')
        }
    }
}

function loadJsTree(data) {
    $('.tree_js').hide();
    $('#types-tree').jstree("destroy");
    $('#types-tree').jstree({
        'core': {
            'themes': { 'responsive': false },
            'data': data,
        },
        'plugins': ['types']
    });


}

function setSkillJson(obj, t, skill, dataObj) {
    if (skill && skill.length > 0) {
        skill.forEach(function(s) {
            var temp = {
                "text": s.name,
                "state": { "opened": true },
                "icon": (t == 'p' ? "feather icon-folder" : "feather icon-feather")
            }
            if (dataObj && dataObj[s.id]) {
                temp["children"] = setSkillJson([], 'c', dataObj[s.id], dataObj);
            }
            obj.push(temp);
        })
    }
    return obj;
}
var dataObj = {};  
function loadSkills() {
    var type = "DESC";
    api.skill.skillsByParent({ type: type }, function (success) {
        $('#skills_append').html('');
        if(success && success.skills && success.skills.length > 0){
            clearExistingSkills();  
            var finalArray = []; 
            success.skills.forEach(function(skill) {
                appendSkills(skill);
                if (!dataObj[skill.parentId]) dataObj[skill.parentId] = [];
                dataObj[skill.parentId].push(skill);
                addExistingSkill(skill);
            });
            setSelectedSkill();
            finalArray = setSkillJson([], 'p', dataObj[0], dataObj);
            loadJsTree(finalArray);
            groupHierarchyRender();  
        }else{
            appendSkills();
            groupHierarchyRender();
            $('.tree_js').show();
        }
    });
}

function ckeckOpenSectionDiv() {
    clearErrors();
    if ($(".section-num").hasClass('active') == true) {
        addError('section box', 'Add Section first');
        hasError() && showErrors();
        return false;
    }
    else
        return true;
}

function addSection(dbSection = undefined) {
    if (dbSection != undefined) {
        sectionCount = dbSection.id;
        var div_check = true;
    } else{
        var div_check = ckeckOpenSectionDiv();
    }
    if (div_check) {
        $('#section-holder').append('<div class="course-block" id="addWhole' + sectionCount + '"><div class="row section_common" id="section-h-' + sectionCount + '"> <div class="col-md-12 px-0 section_co"> <p class="section-text editable-module-1"> <span class="section-num">Section : </span> <span class="section_name_new" id="storeValue-' + sectionCount + '">' + (dbSection != undefined ? dbSection.name : '') + '</span> <span><i class="feather icon-edit ml-2" onclick="editSection(' + sectionCount + ');" data-toggle="tooltip" data-placement="top" data-original-title="Edit"></i> <i class="feather icon-trash-2 mx-2" id="del-sec-' + sectionCount + '" ' + (dbSection == undefined ? 'style="display:none"' : '') + ' onclick="deleteSelection(' + sectionCount + ')" data-toggle="tooltip" data-placement="top" data-original-title="Delete"></i></span></p> <div class="editableClass edit-module-1" id="section_add_rmv-' + sectionCount + '" ' + (dbSection == undefined ? 'style="display:block"' : 'style="display:none"') + ' > <div class="row mx-0 px-0"> <div class="col-md-2 mx-0"> <span class="section-num ' + (dbSection == undefined ? 'active' : '') + '">Enter Section Name </span> </div> <div class="col-md-10 mx-0"> <input type="text" id="section-' + sectionCount + '" name="' + (dbSection != undefined ? dbSection.id : '') + '" value="' + (dbSection != undefined ? dbSection.name : '') + '" class="form-control"> </div> </div> <div class="col-md-12 mx-0 mt-3 text-right"> <button type="button" class=" btn btn-warning edit-btn" onclick="cancelSectionName(' + sectionCount + ')">Cancel</button> <button type="button" class=" btn edit-btn btn-primary" onclick="saveSectionName(' + sectionCount + ')">Save Section</button> </div> </div> </div> </div><div class="lecture_commmon" id="lectureShow' + sectionCount + '"></div><div id="btnShow-' + sectionCount + '" ' + (dbSection == undefined ? 'style="display:none"' : '') + '><button type="button" class="btn btn-success  ml-4" id="addlecture-' + sectionCount + '" onclick="addLecture(' + sectionCount + ')"><i class="feather icon-plus-square mr-2"></i>Add Lecture</button></div></div>');
        $('[data-toggle="tooltip"]').tooltip();
        sectionCount++;
        sec_no++;
    }
};

function editSection(secRem) {
    $('#section_add_rmv-' + secRem).toggle();
}

function validateSection(sectionId) {
    var data = {};
    if (courseId) {
        if ($('#section-' + sectionId).val() == '')
            addError('sectionEr', 'Section Required');
        else
            data.name = sanitize($('#section-' + sectionId).val());
        hasError() && showErrors();
        return data;
    }
}

function deleteSelection(sectionId) {
    var data = {};
    var dbSectionId = $('#section-' + sectionId).attr('name');
    data.sectionId = $('#section-' + sectionId).attr('name');
    data.courseId = courseId;
    if (dbSectionId) {
        swal({
            title: "Warning!",
            type: "warning",
            text: "Are you sure",
            showCancelButton: true,
        })
            .then(function () {
                if (data.sectionId) {
                    api.section.delete(data, function (success) {
                        if (success) {
                            $('#addWhole' + sectionId).remove();
                            showSuccess('Section Deleted');
                        }
                    });
                }
            })
    }
    --sectionCount;
    --sec_no;
}

function sectionAction(sectionId) {
    $('#section_action-' + sectionId).css("display", "block");
    var store = $('#section-' + sectionId).val();
    $('#storeValue-' + sectionId).text(store);
    $('#btnShow-' + sectionId).css({ "display": "block" });
    cancelSectionName(sectionId);
}

function saveSectionName(sectionId) {
    var data = validateSection(sectionId);
    var dbSectionId = $('#section-' + sectionId).attr('name');
    if (data && !dbSectionId) {
        data.courseId = courseId;
        !hasError() && api.section.post(data, function (success) {
            $('#section-' + sectionId).attr('name', success.sectionId);
            showSuccess('Section Saved');
            $('.section-num').removeClass('active');
            sectionAction(sectionId)
            $("#del-sec-" + sectionId).css('display', '');
            $('#tools_sec_' + sectionId).css('display', 'block');
        });
    }
    if (data && dbSectionId) {
        data.sectionId = dbSectionId;
        data.courseId = courseId;
        !hasError() && api.section.patch(data, function (success) {
            showSuccess('Section Updated');
            $('.section-num').removeClass('active');
            sectionAction(sectionId)
        });
    }
}

function cancelSectionName(sectionId) {
    if ($('#storeValue-' + sectionId).text().length == 0) {
        $('#addWhole' + sectionId).remove();
    }
    $('#section_add_rmv-' + sectionId).css({ "display": "none" });
    $('.section-num').removeClass('active');
}

function setType(lectureId, type) {
    $('#type_' + lectureId + '').html('');
    $('#type_' + lectureId + '').html(type);
    $('#quizAllQuestion').html('');
    $('#pdfModal').html('');
    $('#videoModal').html('');
}

function prevDivId() {
    $('.getty').click(function (e) {
        e.preventDefault();
        var x = $(this).prev().attr('id');
        alert(x);
    });
}


function ckeckOpenLectureDiv() {
    clearErrors();
    if ($(".lecture-num").hasClass('active') == true) {
        addError('lecture box', 'Add lecture first');
        hasError() && showErrors();
        return false;
    } else {
        clearErrors();
        return true;
    }

}

function closePreview(lectureId) {
    $('#show-video' + lectureId).removeAttr('src');
    const video = document.querySelector('#show-video' + lectureId);
    video.pause();
}

function previewModal(lectureId) {
    $("#previewModal").html('');
    var type = $('#type_' + lectureId + '').text();
    filename = $('#dbfile_' + lectureId + '').text();
    var src = '';
    if(type == 'pdf')
        src = '/static/course/content/'+filename;
    if(type == 'doc' || type == 'ppt' || type == 'xls')
        src = 'https://view.officeapps.live.com/op/embed.aspx?src='+window.origin+'/static/course/content/'+filename;
    $("#previewModal").append("<div class='modal-dialog' role='document'> <div class='modal-content'><div class='modal-header'> <h5 class='modal-title' id='exampleLargeModalLabel'>Preview File</h5><button type='button' class='close' data-dismiss='modal' aria-label='Close' onclick='closePreview(" + lectureId + ")'> <span aria-hidden='true'>×</span> </button> </div> <div class='modal-body'> <div class='tab-content' id='defaultTabContentLine'> <div class='custom-file'>" + (type == 'video' ? "<video class='w-100 mt-3' width='100%' height='1000%' controls id='show-video" + lectureId + "'  src='/static/course/content/" + filename+"' ></video>" : "<iframe width='100%' height='550' src="+src+"></iframe>") + " <div class='col-md-3 mt-3 p-0'></div> </div> </div> </div>  <div class='modal-footer'> <button type='button' class='btn btn-warning' data-dismiss='modal' onclick='closePreview(" + lectureId + ")'>Close</button></div> </div>")
}

addckediter = function(lecId){
    CKEDITOR.replace( 'lecture-dec-'+lecId, {
        toolbar:[  { name: 'document', groups: [ 'mode', 'document', 'doctools' ] },
            { name: 'clipboard', groups: [ 'clipboard', 'undo' ], items: [ 'Cut', 'Copy', 'Paste', '-', 'Undo', 'Redo' ] },
            { name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ], items: [ 'Bold', 'Italic', 'Underline', '-', 'RemoveFormat' ] },
            { name: 'paragraph', groups: [ 'list', 'indent', 'blocks', 'align', 'bidi', 'paragraph' ], items: [ 'NumberedList', 'BulletedList', '-', 'Outdent', 'Indent', '-', 'Blockquote', '-', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', '-' ] },
            { name: 'links', groups: [ 'links' ], items: [ 'Link', 'Anchor' ] },
            { name: 'styles', groups: [ 'styles' ], items: [ 'Styles', 'Font', 'FontSize' ] },
            { name: 'colors', groups: [ 'colors' ], items: [ 'TextColor', 'BGColor' ] },
            { name: 'tools', groups: [ 'tools' ], items: [ '' ] },
            { name: 'others', groups: [ 'others' ], items: [ '-' ] },
        ],
    } );
}

function addLecture(sectionId, lectures = undefined) {
    //++lectureCount;
    if (lectures != undefined) {
        arr.push(lectures.id);
        lectureCount = lectures.id;
        var div_check = true;
    } else {
        var div_check = ckeckOpenLectureDiv();
        if (arr.length > 0) {
            let arrVal = Object.values(arr);
            let max = Math.max(...arrVal);
            lectureCount = `${max}`;
        }
        ++lectureCount;
        arr.push(parseInt(lectureCount));
    }

    if (div_check) {
        $('#lectureShow' + sectionId).append('<div class="lecture-box" id="lecture-holder-' + lectureCount + '" style="display: block;"> <div class="row" id="editableLecture-1-1"> <div class="col-md-5 px-0"> <p class="lecture-text"> <span class="lecture-num">Lecture : </span> <span id="showLecName-' + lectureCount + '"> ' + (lectures != undefined ? lectures.name : '') + '</span> <span id="lecture_action-' + lectureCount + '" ' + (lectures == undefined ? 'style="display:none;"' : '') + '><i class="feather icon-edit ml-2 lecture-icon" onclick="editLect(' + lectureCount + ')" data-tooltip="tooltip" data-placement="top" data-original-title="Edit"></i> <i class="feather icon-trash-2 mx-2 lecture-icon" onclick="deleteLecture(' + sectionId + ',' + lectureCount + ');" data-tooltip="tooltip" data-placement="top" data-original-title="Delete"></i> </span> </p> </div> <div class="col-md-7 px-0 text-right" id="files_div-' + lectureCount + '" ' + (courseType == "instructor" ? "style='display:none;'" : "") + ' >      <button type="button" class="btn btn-outline-primary check_next ' + (lectures != undefined ? (lectures.type == "pdf" ? "active_btn" : "") : "") + '"  ' + (lectures != undefined ? (lectures.type == "pdf" ? "disabled" : "") : "") + ' id="pdf-' + lectureCount + '" ' + (lectures != undefined ? 'data-toggle="modal" data-target="#pdfModal" ' : '') + ' onclick="pdfModal(' + sectionId + ',' + lectureCount + ', \'pdf\')"> <i class=" fa fa-file-pdf-o mr-2" style="font-size: 16px;"></i>PDF </button>   <button type="button" class="btn btn-outline-primary check_next ' + (lectures != undefined ? (lectures.type == "doc" ? "active_btn" : "") : "") + '"  ' + (lectures != undefined ? (lectures.type == "doc" ? "disabled" : "") : "") + ' id="doc-' + lectureCount + '" ' + (lectures != undefined ? 'data-toggle="modal" data-target="#pdfModal" ' : '') + ' onclick="pdfModal(' + sectionId + ',' + lectureCount + ', \'doc\')"> <i class="fa fa-file-word mr-2" style="font-size: 16px;"></i>DOC </button>  <button type="button" class="btn btn-outline-primary check_next ' + (lectures != undefined ? (lectures.type == "ppt" ? "active_btn" : "") : "") + '"  ' + (lectures != undefined ? (lectures.type == "ppt" ? "disabled" : "") : "") + ' id="ppt-' + lectureCount + '" ' + (lectures != undefined ? 'data-toggle="modal" data-target="#pdfModal" ' : '') + ' onclick="pdfModal(' + sectionId + ',' + lectureCount + ', \'ppt\')"> <i class="fa fa-file-powerpoint mr-2" style="font-size: 16px;"></i>PPT </button>  <button type="button" class="btn btn-outline-primary check_next ' + (lectures != undefined ? (lectures.type == "xls" ? "active_btn" : "") : "") + '"  ' + (lectures != undefined ? (lectures.type == "xls" ? "disabled" : "") : "") + ' id="xls-' + lectureCount + '" ' + (lectures != undefined ? 'data-toggle="modal" data-target="#pdfModal" ' : '') + ' onclick="pdfModal(' + sectionId + ',' + lectureCount + ', \'xls\')"> <i class="fa fa-file-excel-o mr-2" style="font-size: 16px;" ></i>XLS </button>       <button type="button" class="btn btn-outline-primary check_next ' + (lectures != undefined ? (lectures.type == "video" ? "active_btn" : "") : "") + '" ' + (lectures != undefined ? (lectures.type == "video" ? "disabled" : "") : "") + '  ' + (lectures != undefined ? 'data-toggle="modal" data-target="#videoModal"' : '') + ' id="v-' + lectureCount + '" onclick="videoModal(' + sectionId + ',' + lectureCount + ')"> <i class="fa fa-file-video mr-2" style="font-size: 16px;"></i>Video </button> <button type="button" class="btn btn-outline-primary hide-quiz-setting check_next ' + (lectures != undefined ? (lectures.type == "quiz" ? "active_btn" : "") : "") + '" ' + (lectures != undefined ? (lectures.type == "quiz" ? "disabled" : "") : "") + ' id="q-' + lectureCount + '" ' + (lectures != undefined ? 'data-toggle="modal" data-target="#quizModal" ' : '') + ' onclick="quizModal(' + sectionId + ',' + lectureCount + ')" > <i class="fa fa-question-circle mr-2" style="font-size: 16px;"></i>Quiz </button> </div> </div> <div class="editableClass" id="edit-lecture-' + lectureCount + '" ' + (lectures != undefined ? 'style="display:none;"' : '') + ' > <div class="row"> <div class="col-md-2 mx-0 active"> <span class="lecture-num ' + (lectures == undefined ? 'active' : '') + '">Lecture : </span> </div> <div class="col-md-10 mx-0"> <input type="text" ' + (lectures != undefined ? 'name="' + lectures.id + '" value="' + lectures.name + '"' : '') + ' id="lecture-' + lectureCount + '" class="form-control"> </div> </div> <div class="row mt-2"> <div class="col-md-2 mx-0 active"> <span class="lecture-num '+(lectures == undefined ? 'active' : '')+'">Description (optional)</span> </div> <div class="col-md-10 mx-0"> <textarea rows="2" class="form-control" id="lecture-dec-' + lectureCount + '" name =id="lecture-dec-' + lectureCount + '"> ' + (lectures != undefined ?  (lectures.description !=null ? lectures.description : '') : '') + '</textarea> </div>    </div>  <div class="col-md-12 mx-0 mt-3 text-right"> <button type="button" class=" btn btn-warning edit-btn" onclick="closeLecture(' + lectureCount + ')">Cancel</button> <button type="button" class=" btn edit-btn btn-primary" onclick="saveLecture(' + lectureCount + ',' + sectionId + ')">Save Lecture</button> </div> </div><div class="new_border new-div-' + lectureCount + '"  ' + (courseType == "instructor" ? "style='display:none;'" : "") + ' ' + (lectures != undefined ? (lectures.type == null ? 'style="display:none;"' : 'style="display:block;"') : 'style="display:none;"') + ' > <div class="row"> <div class="col-sm-9"> <div class="video_pdf"> <div class="img_video"> <img id="img-' + lectureCount + '"  ' + (lectures != undefined ? 'src="/static/course/content/thumbnail/' + (lectures != undefined ? (lectures.type == 'video' ? lectures.Content.thumbnail : (lectures.type == 'quiz' ? 'quiz.jpeg': lectures.type+'.jpeg') ) : '') + '"' : '') + ' > </div> <div class="video_desc"> <h5><span id="lname-' + lectureCount + '"> ' + (lectures != undefined ? (lectures.type == 'quiz' ? 'Total no. of Questions: '+lectures.questionCount : (lectures.Content ? lectures.Content.originalName : '')) : '') + '</span> <button id="editFile-' + lectureCount + '"  data-toggle="modal" ' + (lectures != undefined ? (lectures.type == 'video' ? 'data-target="#videoModal" onclick="videoModal(' + sectionId + ',' + lectureCount + ')"' : (lectures.type == 'quiz' ? 'data-target="#quizModal" onclick="quizModal(' + sectionId + ',' + lectureCount + ')"' :'data-target="#pdfModal" onclick="pdfModal(' + sectionId + ',' + lectureCount + ', \''+lectures.type+'\')"' ) ) : '') + '  class="btn btn-primary" data-tooltip="tooltip" data-placement="top" data-original-title="Edit"><i class="feather icon-edit"></i></button></h5> <p id="video-pdf-' + lectureCount + '" style="display:' + (lectures != undefined ? (lectures.type == 'video' ? 'block' : 'none') : 'none') + '">Duration :&nbsp;<span id="duration-' + lectureCount + '">' + (lectures != undefined ? (lectures.type == 'pdf' ? toHHMMSS(lectures.totalDuration) : toHHMMSS(lectures.totalDuration)) : '') + '</span>  &nbsp;Hrs</p>  </div> </div> </div>     <div class="col-sm-3 text-right pro_box"> <div class="progress" id="progress-' + lectureCount + '" style="' + (lectures != undefined ? 'display:none;' : 'display:none;') + '"> <div class="progress-bar progress-bar-striped progress-bar-animated running-ajax-upload" role="progressbar" style="width: 0%" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100"></div> </div><button class="btn btn-primary"  id="vp-' + lectureCount + '" style="display:' + (lectures != undefined ? 'inline-block;' : 'none;') + '" '+(lectures != undefined ? (lectures.type == 'quiz' ? 'data-toggle="modal" data-target="#quizModal" onclick="quizModal(' + sectionId + ',' + lectureCount + ')"'  : 'data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#previewModal" onclick="previewModal(' + lectureCount + ')"' ) :'')+'>Preview</button> </div> </div> </div> <span style="display:none;" id="type_' + lectureCount + '">' + (lectures != undefined ? lectures.type : '') + '</span> <span style="display:none;" id="dbfile_' + lectureCount + '">' + (lectures != undefined ? (lectures.Content ? lectures.Content.name : '') : '') + '</span></div>');
        $('[data-tooltip="tooltip"]').tooltip();
        addckediter(lectureCount);
        lectureCount++;
        lect_no++;
    }
}


function deleteLecture(sectionId, lectureId) {
    var data = {};
    var dbSectionId = $('#section-' + sectionId).attr('name');
    data.sectionId = dbSectionId;
    data.lectureId = $('#lecture-' + lectureId).attr('name');
    data.courseId = courseId;
    swal({ title: "Warning!", type: "warning", text: "Are you sure", showCancelButton: true })
        .then(function () {
            api.section.deleteLecture(data, function (success) {
                $('#lecture-holder-' + lectureId).remove();
                --lectureCount;
                showSuccess('Lecture Deleted');
            });
        })
    --lect_no;
}

function validateLecture(lectureId) {
    var data = {};
    if (courseId) {
        //data.description=($('#lecture-dec-' + lectureId).val() != '' ? $('#lecture-dec-' + lectureId).val() : undefined);
        var lecIds=`lecture-dec-${lectureId}`;
        data.description = CKEDITOR.instances[lecIds].getData();
        if ($('#lecture-' + lectureId).val() == '')
            addError('lectureEr', 'Lecture Required');
        else
            data.name = sanitize($('#lecture-' + lectureId).val());
        hasError() && showErrors();
        return data;
    }
}

function setDuration(lectureId) {
    var filename = $('input[name=videoFile-' + lectureId + ']').prop('files')[0];
    ext = filename.name.split('.').pop();
    if (ext == 'mp4') {
        $("#videoFileName-" + lectureId + "").text(filename['name']).css({ "color": "black" });
        setFileDuration(filename);
        getThumbnail(filename, lectureId, undefined);
        setVideo(filename, lectureId);
    } else {
        $("#videoFileName-" + lectureId + "").text('Please choose mp4 file format').css({ "color": "red" });
    }
}

function setFileDuration(file) {
    var video = document.createElement('video');
    video.preload = 'metadata';
    video.onloadedmetadata = function () {
        window.URL.revokeObjectURL(video.src);
        duration = Math.floor(video.duration);
    }
    video.src = URL.createObjectURL(file);
}


function validateFile(type, sectionId, lectureId) {
    var data = new FormData();
    var lecture = $('#lecture-' + lectureId).attr('name');
    var file = '';
    if (lecture == "" || lecture == undefined)
        addError('LectureNotFound', 'Please add Lecture');
    var dbSectionId = $('#section-' + sectionId).attr('name');
    //  var dbLectureId = $('#lecture-'+lectureId).attr('name'); 
    if (type != "") {
        data.append('type', type);
        if (type == 'video') {
            var file = $('input[name=videoFile-' + lectureId + ']').prop('files')[0];
            data.append('thumbnail', thumbnail);
        }
        if (type == 'pdf' || type == 'doc' || type == 'ppt' || type == 'xls')
            var file = $('input[name=pdfFile-' + lectureId + ']').prop('files')[0]
    }
    if (file == '' || file == undefined) {
        $('.invalid').css("border", "1px solid red");
        addError('File', 'Please Upload file first');
        hasError() && showErrors();
        return false;
    } else {
        var addedId = 0;
        if ($('#vp-' + lecture).length == 0)
            addedId = lectureId;

        data.append('addedId', addedId);
        data.append('courseId', courseId);
        data.append('lectureId', lecture);
        data.append('filename', file);
        data.append('duration', duration);
        data.append('sectionId', dbSectionId);
        return data;
    }
}

function base64ImageToBlob(str) {
    if (str) {
        var pos = str.indexOf(';base64,');
        var type = str.substring(5, pos);
        var b64 = str.substr(pos + 8);
        var imageContent = atob(b64);
        var buffer = new ArrayBuffer(imageContent.length);
        var view = new Uint8Array(buffer);
        for (var n = 0; n < imageContent.length; n++) {
            view[n] = imageContent.charCodeAt(n);
        }
        var blob = new Blob([buffer], { type: type });
        return blob;
    }
    else {
        !hasError()
    }
}

function getThumbnail(file, lectureId, videothum) {
    var fileReader = new FileReader();
    if (file.type.match('pdf')) {
        fileReader.onload = function () {
            $('#uploadedImage').attr("src", fileReader.result);
        };
        fileReader.readAsDataURL(file);
    } else {
        showLoader();
        fileReader.onload = function () {
            var blob = new Blob([fileReader.result], { type: file.type });
            var url = URL.createObjectURL(blob);
            var video = document.createElement('video');
            var timeupdate = function () {
                if (snapImage()) {
                    video.removeEventListener('timeupdate', timeupdate);
                    video.pause();
                }
            };
            video.addEventListener('loadeddata', function () {
                if (snapImage()) {
                    video.removeEventListener('timeupdate', timeupdate);
                }
            });
            var snapImage = function () {
                var canvas = document.createElement('canvas');
                canvas.width = video.videoWidth;
                canvas.height = video.videoHeight;
                canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height);
                var image = canvas.toDataURL();
                var success = image.length > 100000;
                if (success) {
                    $('#uploadedImage').attr("src", image);
                    vidImgSrc = image;
                    // if(videothum) 
                    //      $('#img-' + lectureId + '').attr("src", image);
                    thumbnail = base64ImageToBlob($('#uploadedImage').attr('src'));
                    URL.revokeObjectURL(url);
                }
                return success;
            };
            video.addEventListener('timeupdate', timeupdate);
            video.preload = 'metadata';
            video.src = url;
            video.muted = true;
            video.playsInline = true;
            video.play();
            hideLoader();
        };
        fileReader.readAsArrayBuffer(file);
    }
}

function uploadContent(type, sectionId, lectureId) {
    if (type == "video") {
        getFileName = $('input[name=videoFile-' + lectureId + ']').prop('files')[0];
    } else {
        getFileName = $('input[name=pdfFile-' + lectureId + ']').prop('files')[0];
    }
    if (getFileName != undefined) {
        uploadedFileName = getFileName.name;
        var data = validateFile(type, sectionId, lectureId);
        if (data) {
            !hasError() && api.section.uploadLectureFile(data, function (success) {
                if(success){
                    $('.invalid').css("border", "none");
                    var file = '';
                    $(".new-div-" + lectureId).css("display", "block");
                    $("#pdf-" + lectureId + "").removeClass('active_btn').attr("disabled", false);
                    $("#doc-" + lectureId + "").removeClass('active_btn').attr("disabled", false);
                    $("#ppt-" + lectureId + "").removeClass('active_btn').attr("disabled", false);
                    $("#xls-" + lectureId + "").removeClass('active_btn').attr("disabled", false);
                    $('#q-'+lectureId).removeClass('active_btn').attr("disabled", false);
                    $("#v-" + lectureId + "").removeClass('active_btn').attr("disabled", false);
                    if (type == "video") {
                        file = $('input[name=videoFile-' + lectureId + ']').prop('files')[0];
                        //  getThumbnail(file, lectureId, 'videothum');
                        $("#v-" + lectureId + "").addClass('active_btn').attr("disabled", true);
                        $('#video-pdf-' + lectureId).show();
                        $("#duration-" + lectureId + "").text(toHHMMSS(duration));
                        $('#type_' + lectureId + '').text('video');
                        $("#editFile-" + lectureId + "").attr('data-target', '#videoModal').attr('onclick', 'videoModal(' + sectionId + ',' + lectureId + ')').show();
                        $('#vp-'+lectureId).attr('data-backdrop', 'static').attr('data-keyboard', 'false').attr('data-toggle', 'modal').attr('data-target', '#previewModal').attr('id', 'vp-'+lectureId).attr('onclick', 'previewModal(' + lectureId + ')');
                    } else {
                        $("#"+type+"-" + lectureId + "").addClass('active_btn').attr("disabled", true);
                        $('#video-pdf-' + lectureId).hide();
                        file = $('input[name=pdfFile-' + lectureId + ']').prop('files')[0];
                        $('#img-' + lectureId + '').attr("src", "/static/course/content/thumbnail/"+type+".jpeg");
                        $('#type_' + lectureId + '').text(type);
                        $("#editFile-" + lectureId + "").attr('data-target', '#pdfModal').attr('onclick', 'pdfModal(' + sectionId + ',' + lectureId + ', '+type+')');
                        $('#vp-'+lectureId).attr('data-backdrop', 'static').attr('data-keyboard', 'false').attr('data-toggle', 'modal').attr('data-target', '#previewModal').attr('id', 'vp-'+lectureId).attr('onclick', 'previewModal(' + lectureId + ')').show();
                    }
                    vidImgSrc = '';
                    uploadedFileName = '';
                    $("#lname-" + lectureId + "").text(file.name);
                    $('#dbfile_' + lectureId + '').text(success.filename);
                    if ($('.settingCls').hasClass('disabled') == true)
                        $('.settingCls').removeClass('disabled');
                    showSuccess(success.data);
                    //  $('#vp-'+lectureId).css("display","inline-block")
                }
                vidImgSrc = '';
                uploadedFileName = '';
                $("#lname-" + lectureId + "").text(file.name);
                $('#dbfile_' + lectureId + '').text(success.filename);
                if ($('.settingCls').hasClass('disabled') == true)
                    $('.settingCls').removeClass('disabled');
                showSuccess(success.data);
                //  $('#vp-'+lectureId).css("display","inline-block")
            }, function(error) { });
        }
    } else {
        if (type == 'video') {
            $("#videoFileName-" + lectureId + "").text('Please choose file.').css({ "color": "red" });
        } else {
            $("#pdfFileName-" + lectureId + "").text('Please choose file.').css({ "color": "red" });
        }
    }

}

function addAuestion() {
    $('#addAnswer').append(' <div class="row quiz_block"> <div class="col-sm-1 check_box_quiz"> <div class="input-group-prepend"> <div class="input-group-text"> <input type="checkbox" id="checkbox-1" aria-label="Checkbox for following text input"> </div> </div> </div> <div class="col-sm-10"> <textarea class="form-control" id="answer-1" spellcheck="false"></textarea> </div> <div class="col-sm-1 trash_icon"><i class="feather icon-trash-2"></i> </div> </div>')
}

function checkInputData(lectureId) {
    if ($("#showLecName-" + lectureId).text() != ' ')
        return true;
    else {
        addError("no-pdffile", "Save Lecture Name First");
        hasError() && showErrors();
        return false;
    }
}

function setPdfFile(lectureId, type) {
    var filename = $('input[name=pdfFile-' + lectureId + ']').prop('files')[0];
    if (filename) {
        ext = filename.name.split('.').pop().toLowerCase();
        if (ext == 'pdf' || ext == 'docx' || ext == 'doc' || ext == 'ppt' || ext == 'pptx' || ext == 'xls' || ext == 'xlsx')
            $("#pdfFileName-" + lectureId + "").text(filename['name']).css({ "color": "black" });
        else {
            $("#pdfFileName-" + lectureId + "").text('Please choose .'+type+' file format').css({ "color": "red" });
            $('input[name=pdfFile-' + lectureId + ']').val('');
        }
    }
}

function videoModal(sectionId, lectureId) {
    clearErrors();
    var fileType = "video";
    $('#videoModal').html('');
    var check = checkInputData(lectureId);
    if (check) {
        setType(lectureId, 'video');
        $('#videoModal').append("<div class='modal-dialog' role='document'> <div class='modal-content'> <div class='modal-header'> <h5 class='modal-title' id='exampleStandardModalLabel'>Upload File</h5> <button type='button' class='close' data-dismiss='modal' aria-label='Close'> <span aria-hidden='true'>×</span> </button> </div> <div class='modal-body'> <ul class='nav nav-tabs custom-tab-line mb-3' id='defaultTabLine' role='tablist'> <!--<li class='nav-item'> <a class='nav-link active' id='home-tab-line' data-toggle='tab' href='#my-video' role='tab' aria-controls='home-line' aria-selected='true'><i class='feather icon-video mr-2'></i>My Video</a> </li> <li class='nav-item'> <a class='nav-link' id='home-tab-line' data-toggle='tab' href='#predefined-video' role='tab' aria-controls='home-line' aria-selected='true'><i class='feather icon-video mr-2'></i>Predefined Video</a> </li>--> <li class='nav-item'> <a class='nav-link active' id='contact-tab-line' data-toggle='tab' href='#upload-video' role='tab' aria-controls='contact-line' aria-selected='true'><i class='feather icon-upload mr-2'></i>Upload Video</a> </li> </ul> <div class='tab-content' id='defaultTabContentLine'> <div class='tab-pane fade' id='my-video' role='tabpanel' aria-labelledby='home-tab-line' id=''> <div class='row mx-0' id='content'></div> <section id='pagination-wrapper'> <div class='row'> <div class='col-md-6'> <nav aria-label='Page navigation example'> <ul class='pagination' id='pagination0'> </ul> </nav> <div id='pagecount0'> </div> </div> <div class='col-md-6'> <div class='pageNo pull-right' id='gotopage0'> </div> </div> </div> </section> </div> <div class='tab-pane fade' id='predefined-video' role='tabpanel' aria-labelledby='profile-tab-line'> <div class='row'> <div class='col-sm-3'> <video id='video' controls='controls' preload='none' width='600' poster='http://media.w3.org/2010/05/sintel/poster.png'> <source id='mp4' src='http://media.w3.org/2010/05/sintel/trailer.mp4' type='video/mp4' /> <source id='webm' src='http://media.w3.org/2010/05/sintel/trailer.webm' type='video/webm' /> <source id='ogv' src='http://media.w3.org/2010/05/sintel/trailer.ogv' type='video/ogg' /> </video> </div> <div class='col-sm-3'> <video id='video' controls='controls' preload='none' width='600' poster='http://media.w3.org/2010/05/sintel/poster.png'> <source id='mp4' src='http://media.w3.org/2010/05/sintel/trailer.mp4' type='video/mp4' /> <source id='webm' src='http://media.w3.org/2010/05/sintel/trailer.webm' type='video/webm' /> <source id='ogv' src='http://media.w3.org/2010/05/sintel/trailer.ogv' type='video/ogg' /> </video> </div> <div class='col-sm-3'> <video id='video' controls='controls' preload='none' width='600' poster='http://media.w3.org/2010/05/sintel/poster.png'> <source id='mp4' src='http://media.w3.org/2010/05/sintel/trailer.mp4' type='video/mp4' /> <source id='webm' src='http://media.w3.org/2010/05/sintel/trailer.webm' type='video/webm' /> <source id='ogv' src='http://media.w3.org/2010/05/sintel/trailer.ogv' type='video/ogg' /> </video> </div> <div class='col-sm-3'> <video id='video' controls='controls' preload='none' width='600' poster='http://media.w3.org/2010/05/sintel/poster.png'> <source id='mp4' src='http://media.w3.org/2010/05/sintel/trailer.mp4' type='video/mp4' /> <source id='webm' src='http://media.w3.org/2010/05/sintel/trailer.webm' type='video/webm' /> <source id='ogv' src='http://media.w3.org/2010/05/sintel/trailer.ogv' type='video/ogg' /> </video> </div> </div> </div> <div class='tab-pane fade show active' id='upload-video' role='tabpanel' aria-labelledby='profile-tab-line'> <div class='row'><div class='col-sm-12'><div class='custom-file invalid'> <input type='file' class='form-control custom-file-input' name='videoFile-" + lectureId + "' aria-describedby='inputGroupFileAddon01' accept='video/mp4,video/x-m4v,video/*' onchange='setDuration(" + lectureId + ")' id='videoFile-" + lectureId + "'><label class='custom-file-label' for='inputGroupFile01'>Upload Video</label> <img id='uploadedImage' style='display:none;' name='uploadedThumbnail' class='w-50 mt-3'> </div><span style='font-size:12px;color: #e69700;font-weight: 600;'>Accept MP4 video format in maximum 1GB size</span></div>  <div class='col-sm-12'><p class='mt-3 mb-2'><span id='videoFileName-" + lectureId + "'></span></p><video class='w-50 mt-3'  style='display:none;' width='100%' height='auto' controls id='show-video" + lectureId + "'></video></div></div> </div> </div>  </div><div class='modal-footer'> <button class='btn btn-primary w-25 py-2' onclick='uploadContent(\"" + fileType + "\"," + sectionId + "," + lectureId + ")'>Upload</button>  <!--<button type='button' class='btn btn-warning' data-dismiss='modal'>Close</button>--> <!--<button type='button' class='btn btn-primary' data-dismiss='modal'>Save changes</button> --></div> </div>")
    }
}

function pdfModal(sectionId, lectureId, fileType) {
    clearErrors();
    var fileExtension = '';
    if(fileType == 'pdf')
        fileExtension = 'application/pdf';
    if(fileType == 'doc')
        fileExtension = 'application/vnd.openxmlformats-officedocument.wordprocessingml.document, application/msword';
    if(fileType == 'ppt')
        fileExtension = 'application/vnd.ms-powerpoint, application/vnd.openxmlformats-officedocument.presentationml.presentation';
    if(fileType == 'xls')
        fileExtension = 'application/vnd.ms-excel, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet';
    var check = checkInputData(lectureId);
    $('#pdfModal').html('');
    if (check) {
        setType(lectureId, fileType);
        $('#pdfModal').append(' <div class="modal-dialog" role="document"> <div class="modal-content"> <div class="modal-header"> <h5 class="modal-title" id="exampleStandardModalLabel">Upload File</h5> <button type="button" class="close" data-dismiss="modal" aria-label="Close"> <span aria-hidden="true">×</span> </button> </div> <div class="modal-body"> <ul class="nav nav-tabs custom-tab-line mb-3" id="defaultTabLine" role="tablist"><!-- <li class="nav-item"> <a class="nav-link active" id="home-tab-line" data-toggle="tab" href="#my-video" role="tab" aria-controls="home-line" aria-selected="true"><i class="feather icon-video mr-2"></i>My Lecture</a> </li> <li class="nav-item"> <a class="nav-link" id="home-tab-line" data-toggle="tab" href="#predefined-video" role="tab" aria-controls="home-line" aria-selected="true"><i class="feather icon-video mr-2"></i>Predefined Lecture</a> </li> --><li class="nav-item active"> <a class="nav-link" id="contact-tab-line" data-toggle="tab" href="#upload-video" role="tab" aria-controls="contact-line" aria-selected="false"><i class="feather icon-upload mr-2"></i>Upload '+fileType.toUpperCase()+'</a> </li> </ul> <div class="tab-content" id="defaultTabContentLine"> <div class="tab-pane fade" id="my-video" role="tabpanel" aria-labelledby="home-tab-line"> <div class="row"> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="http://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="htupload-tp://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="http://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="http://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> </div> </div> <div class="tab-pane fade" id="predefined-video" role="tabpanel" aria-labelledby="profile-tab-line"> <div class="row"> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="http://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="http://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="http://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> <div class="col-sm-3"> <video id="video" controls="controls" preload="none" width="600" poster="http://media.w3.org/2010/05/sintel/poster.png"> <source id="mp4" src="http://media.w3.org/2010/05/sintel/trailer.mp4" type="video/mp4" /> <source id="webm" src="http://media.w3.org/2010/05/sintel/trailer.webm" type="video/webm" /> <source id="ogv" src="http://media.w3.org/2010/05/sintel/trailer.ogv" type="video/ogg" /> </video> </div> </div> </div> <div class="tab-pane fade show active" id="upload-video" role="tabpanel" aria-labelledby="profile-tab-line"> <div class="row"><div class="col-sm-12"><div class="custom-file invalid"> <input type="file" class="custom-file-input" aria-describedby="inputGroupFileAddon01" name="pdfFile-' + lectureId + '" onchange="setPdfFile(' + lectureId + ', \''+fileType+'\')" id="pdfFile-' + lectureId + '" accept="'+fileExtension+'"> <p class="mt-3 mb-2"><span id="pdfFileName-' + lectureId + '"></span></p> <label class="custom-file-label" for="inputGroupFile01">Upload '+fileType.toUpperCase()+'</label>  </div><span style="font-size:12px;color: #e69700;font-weight: 600;"">Upload '+fileType+' file in not more than 1GB size</span></div></div> </div> </div> </div> <div class="modal-footer"> <button class="btn btn-primary w-25 py-2" onclick="uploadContent(\'' + fileType + '\',' + sectionId + ',' + lectureId + ')">Upload</button> </div> </div> </div>');
    }
}

function fileDisplayFunction(lectureId) {
    if ($('#files_div-' + lectureId + '').css('display') == "none") {
        $('#files_div-' + lectureId + '').css({ "display": "block" });
    } else if ($('#files_div-' + lectureId + '').css('display') == "block")
        $('#files_div-' + lectureId + '').css({ "display": "none" });
}

function editLect(editLec) {
    // fileDisplayFunction(editLec);
    $('#edit-lecture-' + editLec).toggle();
}

function setLectureData(lectureId) {
    var lecture = $('#lecture-' + lectureId).val();
    $('#lecture-dec-' + lectureId).val();
    $('#showLecName-' + lectureId).text(lecture);
    $('#lecture_action-' + lectureId).css('display', 'block');
    $('.lecture-num').removeClass('active');
}

function saveLecture(lectureId, sectionId) {
    var data = validateLecture(lectureId);
    var dbSectionId = $('#section-' + sectionId).attr('name');
    var dbLectureId = $('#lecture-' + lectureId).attr('name');
    if (dbLectureId == undefined) {
        data.sectionId = dbSectionId;
        data.courseId = courseId;
        !hasError() && api.section.createLecture(data, function (success) {
            setLectureData(lectureId);
            closeLecture(lectureId);
            $('#lecture-' + lectureId).attr('name', success.lectureId);
            $("#v-" + lectureId + "").attr('data-toggle', 'modal').attr('data-target', '#videoModal');
            $("#pdf-" + lectureId + "").attr('data-toggle', 'modal').attr('data-target', '#pdfModal');
            $("#doc-" + lectureId + "").attr('data-toggle', 'modal').attr('data-target', '#pdfModal');
            $("#ppt-" + lectureId + "").attr('data-toggle', 'modal').attr('data-target', '#pdfModal');
            $("#xls-" + lectureId + "").attr('data-toggle', 'modal').attr('data-target', '#pdfModal');
            $("#q-" + lectureId + "").attr('data-toggle', 'modal').attr('data-target', '#quizModal');
            showSuccess('Lecture Saved');
            if (courseType == "instructor") {
                if ($('.settingCls').hasClass('disabled') == true)
                    $('.settingCls').removeClass('disabled');
            }
        });
    } else if (dbLectureId != undefined) {
        data.courseId = courseId;
        data.lectureId = dbLectureId;
        !hasError() && api.section.updateLecture(data, function (success) {
            setLectureData(lectureId);
            closeLecture(lectureId);
            showSuccess('Lecture Updated');
        });
    }
}

function closeLecture(lectureId) {
    $('#edit-lecture-' + lectureId).css({ "display": "none" });
    if ($.trim($('#showLecName-' + lectureId).text()).length == 0) {
        $('#lecture-holder-' + lectureId).remove();
    }
    $('.lecture-num').removeClass('active');
    --lectureCount;
}
//JS CODE ADDED
function groupHierarchyRender() {
    $("#accordian a").click(function () {
        var link = $(this);
        var closest_ul = link.closest("ul");
        var parallel_active_links = closest_ul.find(".active")
        var closest_li = link.closest("li");
        var link_status = closest_li.hasClass("active");
        var count = 0;
        closest_ul.find("ul").slideUp(function () {
            if (++count == closest_ul.find("ul").length)
                parallel_active_links.removeClass("active");
        });
        if (!link_status) {
            closest_li.children("ul").slideDown();
            closest_li.addClass("active");
        }
        $('#accordian').click(function(){
            if ($('#accordian').offset().top + $('#accordian').outerHeight() < $('.footerbar').offset().top) { 
            $('#accordian').css({"bottom":"0"});
            } 
        })
    })
}

$(document).click(function (e) {
  //  alert()
    var container = $("#skills_append");
    if ($(e.target).is('.accor a') || $(e.target).is('.accor a input')) {
        container.show();
    }
    else {
         container.hide();
    }

});
$(document).click(function (e) {
    //  alert()
      var container = $("#existing-skill");
      if ($(e.target).is('.accor a') || $(e.target).is('.accor a input')) {
          container.show();
      }
      else {
           container.hide();
      }
  
  });

$(document).click(function (e) {
    //  alert()
      var container = $("#existing-skill");
      if ($(e.target).is('.accord a') || $(e.target).is('.accord a input')) {
          container.show();
      }
      else {
           container.hide();
      }
  
  });

function setSelectedSkill() {
    $('#added-skills').html('').html(' <i class="fa fa-lg fa-tasks"></i>');
    var checkedVals = $('.group-radio:checkbox:checked').map(function () {
        return $('#added-skills').append('<span id="grp-' + this.id + '">' + this.value + '<i class="feather icon-x" onclick="removeSkill(' + this.id + ')"></i></span>');
    }).get();
    if(checkedVals.length == 0)
        $('#added-skills').html('<i class="fa fa-lg fa-tasks"></i>Select Skill Type');
}

function removeSkill(skillId) {
    var count = 0;
    var checkedVals = $('.group-radio:checkbox:checked').map(function () {
        ++count;
    }).get();
    if (count == 1) $('#added-skills').html('<i class="fa fa-lg fa-tasks"></i>Select Skill Type');
    $("#grp-" + skillId + "").remove();
    $("#" + skillId + "").prop('checked', false);
}

function validateCourse() {
    clearErrors();
    var formdata = new FormData();
    var courseName = sanitize($('#courseName').val());
    /* var courseDetail = $('#courseDescription').val(); */
    var courseDetail = CKEDITOR.instances['courseDescription'].getData();
    var language = $("#inputState").val();
    if (courseName.length == 0) {
        $("#courseName").addClass("is-invalid");
        addError('name', 'Course Name is required field');
    }
    if ($('input[name=courselogo]').prop('files')[0]) {
        formdata.append('logo', $('input[name=courselogo]').prop('files')[0]);
    }
    var allSkills = $('.group-radio:checkbox:checked').map(function () {
        return this.id;
    }).get().join(",");
    if (allSkills == '') {
        // $("#accordian").addClass("is-invalid");
        addError('skills', 'Skill field is required');
    }

    if (!$('input[name=courselogo]').prop('files')[0] && courseId <= 0) {
        $("#filePhoto").addClass("is-invalid");
        addError('noFile', 'File required');
    }

    if (courseType == "instructor") {
        var duration = $("#duration").val();
        var time = $("#time").val();
        var date = $("#default-date").val();
        var instructorDetail = '';
        if (duration == '') {
            addError('duration', 'Duration required');
        }
        if (date == '') {
            addError('date', 'Date required');
        }
        if (time == '') {
            addError('time', 'Time required');
        }
        if (duration != '' && time != '' && date != '') {
            instructorDetail = JSON.stringify({ "duration": duration, "time": time, "date": date });
        }
        formdata.append('instructorDetail', instructorDetail);

    }

    hasError() && showErrors();
    if (courseId > 0)
        formdata.append('courseId', courseId);
    formdata.append('name', courseName);
    formdata.append('description', courseDetail);
    formdata.append('languageName', language);
    formdata.append('skills', allSkills);
    formdata.append('courseType', courseType);
    return formdata;
}

function showCurriculum() {
    setCurriculum();
    $('.tab-pane').removeClass('active show');
    $('#detail-tab').removeClass('active');
    $('#curriculum-tab').addClass('active');
    $('#curriculum').addClass('active show');
}

function saveCourse(type = undefined) {
    if (courseId > 0) {
        var data = validateCourse();
        $(".form-control").removeClass("is-invalid");
        !hasError() && api.courseId.patch(courseId, data, function(success) {
            showSuccess('Course has been updated!');
            showCurriculum();
            if (type == 'draft')
                callCourseList();
        });
    } else {
        var data = validateCourse();
        setTimeout(function () {
            $(".form-control").removeClass("is-invalid");
        }, 2000);
        if (!hasError()) {
            showLoader();
            api.course.post(data, function(success) {
                if (success && success.success) {
                    window.location = '/course/create/' + success.id + '?type=curriculum';
                    showSuccess('Course has been Added!');
                    showCurriculum();
                    if (type == 'draft')
                        callCourseList();
                }
            });
            //hideLoader();
        }
    }
    // showCurriculum();
}

function loadLanguages(languageId) {
    api.course.language(undefined, function(success) {
        // $('.inputLang').append('<option disabled selected >Choose Language...</option>')
        for (var i = 0; i < success.languages.length; i++) {
            var selected = '';
            if ((languageId != undefined ? languageId == success.languages[i].id : 24 == success.languages[i].id) ) selected = 'selected';
            $('.inputLang').append('<option name="type" ' + selected + ' value="'+success.languages[i].id+'">' + success.languages[i].name + '</option>')
        }
    })
}

function queryString() {
    var queryString = window.location.search.substring(1);
    var varArray = queryString.split("=");
    var param = varArray[1];
    return param;
}

function setBar(percentage){
	$("#range-slider-own-numbers").ionRangeSlider({
		type: "single",
		grid: true,
		from: (percentage > 0 ? percentage : 10),
		to: 10,
		min : 0,
		max : 100,
		//values: [0, 10, 20, 30, 40, 50, 60, 70, 80,90,100]
	});
}

function courseSettingAppend(p) {
    //if(setting == false){
    if (courseType == "streaming") {
        $('#courseSetting').html('').append('<div class="row"> <div class="col-sm-4 mb-3"> <h5>Lecture Switching <i class="feather icon-help-circle"  data-toggle="tooltip" data-placement="top" title="" data-original-title="Enable this feature to allow the learners to skip the lecture and jump to the next lecture."></i></h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox" class="custom-control-input" name="setting1" value="lecture_switching"  id="setting1"> <label class="custom-control-label" for="setting1"></label> </div> </div> </div> <div class="row mb-3"> <div class="col-sm-4"> <h5>Video Seeking <i class="feather icon-help-circle"  data-toggle="tooltip" data-placement="top" title="" data-original-title="This feature enables the learner to forward the time frame of the lecture video."></i></h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox"  value="video_seeking" class="custom-control-input" name="setting2" id="setting2"> <label class="custom-control-label" for="setting2"></label> </div> </div> </div> <div class="button_cor"></div>       <div class="row hide-quiz" style="display:none;"> <div class="col-sm-4 mb-3"> <h5>Allow Quiz Before Video <i class="feather icon-help-circle"  data-toggle="tooltip" data-placement="top" title="" data-original-title="Enable this feature to allow the learners to skip the lecture and jump to the next lecture."></i></h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox" class="custom-control-input" name="setting3" value="quiz_before_video"  id="setting3"> <label class="custom-control-label" for="setting3"></label> </div> </div> </div>    <div class="row hide-quiz" style="display:none;"> <div class="col-sm-4 mb-3"> <h5>Allow Quiz Failed Reminder <i class="feather icon-help-circle"  data-toggle="tooltip" data-placement="top" title="" data-original-title="Enable this option to send the reminder email to the learners who have failed the quiz."></i></h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox" class="custom-control-input" name="setting4" checked value="quiz_fail_reminder" id="setting4"> <label class="custom-control-label" for="setting4"></label> </div> </div> </div>         <div class="row mb-3 hide-quiz" style="display:none;"> <div class="col-sm-4"> <h5>Quiz Passing Percentage <i class="feather icon-help-circle"  data-toggle="tooltip" data-placement="top" title="" data-original-title="This feature enables the learner to forward the time frame of the lecture video."></i></h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch" style="padding:0"> <input id="range-slider-own-numbers"> </div> </div> </div> <div class="button_cor"></div>     <div id="setting-buttons" role="tabpanel" aria-labelledby="course-tab"> <button type="button" id="published"  class="btn btn-success" onclick="setStatus(1)"' + (courseStatus == 'Active' || courseStatus == 'Draft' ? 'disabled' : '') + ' ' + (courseStatus == 'Published' ? 'disabled' : '') + ' >' + (courseStatus == 'Published' ? 'Published' : 'Publish') + '</button> <button type="button" id="unpublished" onclick="setStatus(2)" ' + (courseStatus == 'Active' || courseStatus == 'Draft' ? 'disabled' : '') + ' ' + (courseStatus == 'Unpublished' ? 'disabled' : '') + ' class="btn btn-success">' + (courseStatus == 'Unpublished' ? 'Unpublished' : 'Unpublish') + '</button><p><b>Note : </b> Publish/Unpublish option will become available after you run the course campaign.</p> </div> ');
        $('[data-toggle="tooltip"]').tooltip();
        setBar(p)
    }
    if (courseType == "instructor") {
        //<div class="row"> <div class="col-sm-4 mb-3"> <h5>Allow user join as moderators</h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox" class="custom-control-input" name="user_as_moderator" value="user_as_moderator"  id="user_as_moderator"> <label class="custom-control-label" for="user_as_moderator"></label> </div> </div> </div> 
        $('#courseSetting').html('').append('<div class="row"> <div class="col-sm-4 mb-3"> <h5>Mute users when they join</h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox" class="custom-control-input" name="mute_users" value="mute_users"  id="mute_users"> <label class="custom-control-label" for="mute_users"></label> </div> </div> </div><div class="row"> <div class="col-sm-4 mb-3"> <h5>Require moderator approval before joining</h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox" class="custom-control-input" name="moderator_approval" value="moderator_approval"  id="moderator_approval"> <label class="custom-control-label" for="moderator_approval"></label> </div> </div> </div><div class="row"> <div class="col-sm-4 mb-3"> <h5>Allow any user to start this meeting</h5> </div> <div class="col-sm-4"> <div class="custom-control custom-switch"> <input type="checkbox" class="custom-control-input" name="user_start_meeting" value="user_start_meeting"  id="user_start_meeting"> <label class="custom-control-label" for="user_start_meeting"></label> </div> </div> </div><p id="meeting_text"></p> <div class="row mb-4 mt-3" id="createMeetingDiv"> <div class="col-sm-12"> <div class="custom-control custom-checkbox"> <input type="checkbox" class="custom-control-input" id="customMet" onclick="checkAboveSetting()"> <label class="custom-control-label" for="customMet">I agree with the above meeting settings.</label> </div> <button type="button" class="btn btn-primary" id="createMet" onclick="createMetting();" disabled>Create Meeting</button> </div> </div><div class="button_cor"></div> <div id="setting-buttons" role="tabpanel" aria-labelledby="course-tab"><button type="button" id="published"  class="btn btn-success" onclick="setStatus(1)" ' + (courseStatus == 'Active' || courseStatus == 'Draft' ? 'disabled' : '') + ' ' + (courseStatus == 'Published' ? 'disabled' : '') + ' >' + (courseStatus == 'Published' ? 'Published' : 'Publish') + '</button> <button type="button" id="unpublished" onclick="setStatus(2)" ' + (courseStatus == 'Active' || courseStatus == 'Draft' ? 'disabled' : '') + ' ' + (courseStatus == 'Unpublished' ? 'disabled' : '') + ' class="btn btn-success">' + (courseStatus == 'Unpublished' ? 'Unpublished' : 'Unpublish') + '</button> <p><b>Note : </b> Publish/Unpublish option will become available after you run the course campaign.</p></div> ');
        $('[data-toggle="tooltip"]').tooltip();
    }
    //}
}

function createMetting() {
    var mute_users = ($('#mute_users').is(':checked') ? true : false);
    var moderator_approval = ($('#moderator_approval').is(':checked') ? true : false);
    var user_start_meeting = ($('#user_start_meeting').is(':checked') ? true : false);
    // var user_as_moderator = ($('#user_as_moderator').is(':checked')  ? true : false);
    settings = JSON.stringify({ "muteOnStart": mute_users, "guestPolicy": moderator_approval, "userStartMeeting": user_start_meeting /*, "lockSettingsLockedLayout" : user_as_moderator */ });
    api.course.createMeeting({ settings: settings, courseId: courseId }, function (success) {
        if (success && success.success) {
            showSuccess('Your meeting has been created.!');
            $("#customMet").prop('checked', false);
            $("#createMet").prop("disabled", true);
            $("#meeting_text").html("<b style='color:green;'>Meeting has been created.</b>");
            $("#createMeetingDiv").css("display", "none");
        }
    });
}

function checkAboveSetting() {
    if ($("#customMet").prop('checked') == true)
        $("#createMet").removeAttr('disabled');
    else
        $("#createMet").prop("disabled", true);
}

function getSettings() {
    var settings = '';
    var status = 'Active';
    clearErrors();
    if (courseType == 'streaming') {
        var quiz_percentage = $('#range-slider-own-numbers').val();
        if(quiz_percentage == 0){
            addError('range-slider-own-numbers', 'Quiz Percentage required');
            hasError() && showErrors();
        }
        var lecture = ($('#setting1').is(':checked') ? true : false);
        var video = ($('#setting2').is(':checked') ? true : false);
        var quiz = ($('#setting3').is(':checked') ? true : false);
        var quiz_fails = ($('#setting4').is(':checked') ? true : false);
        settings = JSON.stringify({ "lecture_switching": lecture, "video_seeking": video, "quiz_before_video": quiz, "quiz_passing_percentage": quiz_percentage, quiz_fail_reminder: quiz_fails });
        
    } else {
        var mute_users = ($('#mute_users').is(':checked') ? true : false);
        var moderator_approval = ($('#moderator_approval').is(':checked') ? true : false);
        var user_start_meeting = ($('#user_start_meeting').is(':checked') ? true : false);
        // var user_as_moderator = ($('#user_as_moderator').is(':checked')  ? true : false);
        settings = JSON.stringify({ "muteOnStart": mute_users, "guestPolicy": moderator_approval, "userStartMeeting": user_start_meeting /*, "lockSettingsLockedLayout" : user_as_moderator */ });
    }
    if (courseStatus == 'Published' || courseStatus == 'Unpublished')
        status = courseStatus;
    !hasError() && api.course.setting({ settings: settings, courseId: courseId, status: status }, function (success) {
        if (success) {
            window.location.href = '/course/list';
        }
    });

}


function checkCurriculumExisence() {
    api.course.checkCurriculum({ courseId: courseId }, function(success) {
        if (success.success) {
            if (setting == false)
                courseSettingAppend(10);
            $('.hide-quiz').hide();
            if($('.hide-quiz-setting').hasClass('active_btn') == true){
                $('.hide-quiz').show();
            }
            $('.settingCls').removeClass('disabled');
            $("#courseSetting").css("dispaly", "block");
            if ($('.settingCls').hasClass('active') == true) {
                $('#finishButton').css('display', 'block');
                $('#nextButton').css('display', 'none');
                $('#draftButton').css('display', 'none');
            } else {
                $('#nextButton').css('display', 'block');
                if (courseStatus == 'Draft')
                    $('#draftButton').css('display', 'block');
            }
            return true;
        } else {
            $("#courseSetting").css("dispaly", "none")
            return false;
        }
    }, function(error) {
        $("#courseSetting").css("dispaly", "none")

    })
}

function setSettings(data) {
    setting = true;
    $("#courseSetting").css("dispaly", "block");
    var newData = JSON.parse(data);
    if (courseType == "streaming") {
        $('#setting1').attr("checked", "checked");
        if (newData.lecture_switching) {
            $('#setting1').attr("checked", "checked");
        } else if (newData.lecture_switching == false)
            $('#setting1').removeAttr("checked", "checked");
        if (newData.video_seeking) {
            $('#setting2').attr("checked", "checked");
        }
        if (newData.quiz_before_video) {
            $('#setting3').attr("checked", "checked");
        }
        if (newData.quiz_fail_reminder) {
            $('#setting4').attr("checked", "checked");
        }else  $('#setting4').removeAttr("checked");
        // console.log(newData.quiz_passing_percentage);
    }
    if (courseType == "instructor") {
        if (newData.muteOnStart)
            $('#mute_users').attr("checked", "checked");
        if (newData.guestPolicy)
            $('#moderator_approval').attr("checked", "checked");
        if (newData.userStartMeeting)
            $('#user_start_meeting').attr("checked", "checked");
        // if(newData.lockSettingsLockedLayout)
        //     $('#user_as_moderator').attr("checked","checked");
    }

    var type = queryString();
    if (type == 'curriculum')
        setCurriculum();
    if (type == 'course')
        setDetail();
}

function load() {
    hideLoader();
    api.course.get({ id: courseId }, function(success) {
        if (success.course.courseType)
            courseType = success.course.courseType;
        if (courseType == "instructor")
            $(".instructorDiv").css("display", "block")
        courseStatus = success.course.status;
        if (courseStatus != 'Draft')
            $('#draftButton').css('display', 'none');
        else
            $('#draftButton').css('display', 'block');
        // if(courseStatus == 'Unpublished' || courseStatus == 'Published'){
        //  $('#setting-buttons').html('<button type="button" id="published"  class="btn btn-success" onclick="setStatus(1)" '+(courseStatus == 'Published' ? 'disabled': '')+' >'+(courseStatus == 'Published' ? 'Published': 'Publish')+'</button> <button type="button" id="unpublished" onclick="setStatus(2)" '+(courseStatus == 'Unpublished' ? 'disabled': '')+' class="btn btn-success">'+(courseStatus == 'Unpublished' ? 'Unpublished': 'Unpublish')+'</button> ');
        // }
        if (success.course.setting != null) {
            var perc = JSON.parse(success.course.setting);
            courseSettingAppend((perc.quiz_passing_percentage ? perc.quiz_passing_percentage : 10));
            setSettings(success.course.setting);
        }
        loadLanguages(success.course.languageId);
        courseStatus = success.course.status;
        success.course.CourseSkills.forEach(function(skill) {
            dbSkills.push(skill.skillId);
        })
        loadSkills();
        hideLoader();
        $('#courseName').val(success.course.name);
        $('#courseDescription').val(success.course.description);
        $('#output').attr('src', "/static/course/logo/" + success.course.logo);
        if (success.course.instructorDetail) {
            var d = JSON.parse(success.course.instructorDetail);
            $("#duration").val(d.duration);
            $("#time").val(d.time)
            $("#default-date").val(d.date)
            if (d.expired != undefined) {
                if (d.expired == 1)
                    $("#meeting_text").html("<b style='color:red;'>Meeting has been expired.Create new meeting</b>");
                if (d.expired == 0) {
                    $("#meeting_text").html("<b style='color:green;'>Meeting has been created.</b>");
                    $("#createMeetingDiv").css("display", "none");
                }
            }
        }
    }, function(err) {
        hideLoader();
    })
    return true;
}

function callCourseList() {
    window.location.href = '/course/list';
}

function clearExistingSkills() {
    $('#skillNewName').html('');
}

function showSettings(type = undefined) {
    if ($('.settingCls').hasClass('disabled') == false) {
        var nextLength = $('.check_next').length;
        var count = 0;
        var a = $('.check_next').map(function () {
            if($(this).hasClass('active_btn'))
                ++count;
        }).get();
        if(count != (nextLength/6)){
            if (courseType == "streaming")
                addError("currErr", "Upload atleast one quiz or file in lecture");
            hasError() && showErrors();
        }else{
            checkCurriculumExisence();
            $(".tab-pane").removeClass("active show")
            $(".nav-link").removeClass("active");
            $('#courseSetting').addClass("active show");
            $("#setting-tab").addClass("active");
            $("#finishButton").css("display", "block");
            if (type == 'draft')
                callCourseList();
            if (type == 'next_curriculum') {
                $('.curriculumCls').removeClass('active');
                $('.settingCls').addClass('active');
            }
        }
    } else {
        if (courseType == "streaming")
            addError("currErr", "Upload atleast one quiz or file in lecture");
        if (courseType == "instructor")
            addError("currErr", "Atleast one lecture required");
        hasError() && showErrors();

    }
}

function appendSkills(group) {
    if (group != undefined) {
        if (group.parentId == 0) {
            $('#skills_append').append('<li id="skills_append-' + group.id + '"><a><input type="checkbox" id="' + group.id + '" value="' + group.name + '" ' + (dbSkills.includes(group.id) ? 'checked' : '') + ' name="skills[]" class="group-radio" onclick="setSelectedSkill()"> <label for="' + group.id + '"> ' + group.name + '</label></a></li>');
        } else {
            if (!$('#skills_append-' + group.parentId).has('ul').length)
                $('#skills_append-' + group.parentId).append('<ul></ul>');
            $('#skills_append-' + group.parentId + ' > ul').append('<li id="skills_append-' + group.id + '"><a><input type="checkbox"  id="' + group.id + '" class="group-radio" name="skills[]" value="' + group.name + '" ' + (dbSkills.includes(group.id) ? 'checked' : '') + ' onclick="setSelectedSkill()"> <label for="' + group.id + '"> ' + group.name + '<label></a></li>')
        }
    } else {
        $('#skills_append').append('<li >No Skill Found.</li>');
    }
}

function setStatus(statusId) {
    if (statusId == 1) {
        status = "Published";
    } else if (statusId == 2) {
        status = "Unpublished";
    }
    if (status != '') {
        swal({ title: "Warning!", type: "warning", text: "Are you sure ?", showCancelButton: true })
            .then(function () {
                api.course.courseStatus({ status: status, courseId: courseId }, function (success) {
                    courseStatus = status;
                    if (statusId == 1) {
                        $('#published').attr('disabled', 'disabled').text('Published');
                        $('#unpublished').removeAttr("disabled").text('Unpublish');
                    } else if (statusId == 2) {
                        $('#unpublished').attr('disabled', 'disabled').text('Unpublished');
                        $('#published').removeAttr("disabled").text('Publish');
                    }
                })
            })
    }
}


function readURL(input) {
    if (input.files && input.files[0]) {
        var filename = input.files[0].name;
        ext = filename.split('.').pop().toLowerCase();
        if (ext == 'png' || ext == 'jpeg' || ext == 'jpg' || ext == 'gif') {
            var reader = new FileReader();
            reader.onload = function (e) {
                $('#output').attr('src', e.target.result);
                $('#h2').addClass('img_show_upload');
            }
            reader.readAsDataURL(input.files[0]);
        } else {
            $('#filePhoto').val('');
            addError('ext', 'Please choose jpeg, jpg and png file format');
            hasError() && showErrors();
        }
    }
}
$("#filePhoto").change(function () {
    readURL(this);
});


$('#filePhoto').change(function () {
    // var i = $(this).prev('label').clone();
    // $('#filePhoto').val('');
    var file = $('#filePhoto')[0].files[0].name;
    ext = file.split('.').pop().toLowerCase();
    if (ext == 'png' || ext == 'jpeg' || ext == 'jpg' || ext == 'gif')
        $(this).next('label').text(file);
    else {
        $('#filePhoto').val('');
        $(this).next('label').text('Choose file');
    }
});


//END

function setVideo(file, lectureId) {
    if (file.type == "video/mp4") {
        if (!file || !window.FileReader) return;
        if (/^video/.test(file.type)) {
            var reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onloadend = function () {
                var video = document.getElementById('play-file');
                $("#show-video" + lectureId + "").attr('src', this.result).css("display", "block");
            }
        }
    }
}

function setDetail() {
    if (courseStatus == 'Draft')
        $('#draftButton').css('display', 'block');
    $('#nextButton').css('display', 'block');
    $('#finishButton').css('display', 'none');
    $('#draftLink').removeAttr("onclick", "showSettings()").attr("onclick", "saveCourse(this.name)");
    $('#nextLink').removeAttr("onclick", "showSettings()").attr("onclick", "saveCourse()");
    $(".tab-pane").removeClass("active show");
    $("#detail").addClass("active show");

}

$('#detail-tab').on('click', function (event) {
    setDetail();
});

function setCurriculum() {
    if (courseStatus == 'Draft')
        $('#draftButton').css('display', 'block');
    $('#nextButton').css('display', 'block');
    $('#finishButton').css('display', 'none');
    $('#draftLink').removeAttr("onclick", "saveCourse()").attr("onclick", "showSettings(this.name)");
    $('#nextLink').removeAttr("onclick", "saveCourse()").attr("onclick", "showSettings(this.name)");
    $(".tab-pane").removeClass("active show");
    $("#curriculum").addClass("active show");
}

$('#curriculum-tab').on('click', function (event) {
    setCurriculum();
});

$('#setting-tab').on('click', function (event) {
    checkCurriculumExisence();
    $('#draftButton').css('display', 'none');
    $('#nextButton').css('display', 'none');
    $('#finishButton').css('display', 'block');
    $('#draftLink').removeAttr("onclick", "saveCourse()").removeAttr("onclick", "showSettings(this.name)");
    $('#nextLink').removeAttr("onclick", "saveCourse()").removeAttr("onclick", "showSettings(this.name)");
    $(".tab-pane").removeClass("active show");
    $("#courseSetting").addClass("active show");
});

$(document).ready(function (e) {
    if (courseId) {
        $('.curriculumCls').removeClass('disabled');
        checkCurriculumExisence();
        var type = queryString();
        if (type == 'curriculum')
            showCurriculum();
        else if(type == 'course')
        $('.nav-tabs li:first-child a').tab('show'); 
            if( load()){
                api.section.get({ courseId: courseId }, function (success) {
                    if (success.section){
                        success.section.forEach(function(s) {
                            addSection(s);
                            lect_no = 1;
                            s.CourseSectionLectures.forEach(function(lectures) {
                                addLecture(s.id, lectures);
                                ++lectureCount;
                            });
                        });
                    }
                })
        }
    } else {
        courseType = queryString();
        if(courseType == "instructor")
            $(".instructorDiv").css("display","block")
             $('.nav-tabs li:first-child a').tab('show'); 
        $('#draftButton').css('display','block');
        loadLanguages();
        loadSkills();
    }
});