import { db } from "../../../../models";
import { differentDateFormat } from '../../../../functions';

export default {
    async index(req, res) {
        var error = '';
        db.AppsumoCode.findOne({ where: { name: req.params.id, status: 1 } })
        .then(code => {
            if(code){
                var nowDate = differentDateFormat(5);
                var expiredDate = differentDateFormat(5, code.expiredAt);
                if(nowDate > expiredDate) error = 'Code has been Expired';
            }else error = 'Invalid Code';
            return res.render('appsumo', {layout:'appsumo', code: req.params.id, error: error} );
        })
    }
};