import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import billingController from './billing.controller';
import { userPermission } from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const billingRouter = express.Router();
billingRouter.route('/billing').get(jwtStrategy , userImplant,userPermission('billing-read') ,billingController.index);