import {db} from '../../../../models';
import config from '../../../../config'

export default {
    async index(req, res, next) {
        // console.log(res)
        return res.render('course');
    },

    async courseSetting(req, res, next) {
        return res.render('course-setting');
    },
    async add(req, res, next) {
        return res.render('create-course',{ 'id' : 0 });
    },
    async edit(req, res, next) {
        if(req.params.id > 0){ 
        db.Course.findOne({where: {id: req.params.id, companyId: req.user.companyId },attributes:['name', 'description', 'courseType'],/* include: [{model: db.CourseSection ,required: false, include: [{ model : db.CourseSectionLecture , required: false}]}] */})
            .then(course => {
                if(course){
                   return res.render('create-course', {'id': req.params.id, 'course':JSON.parse(JSON.stringify(course)), type: course.courseType});
                }else{
                    return res.render('404');
                }
            })
            .catch(err => {
                res.status(500).send('Course doesn\'t Exists');
            })
        }else{
            res.status(500).send('Invalid Course Id');
        }
    },

    async get_url(req, res, next) {
        var courseId = encrypt(req.query.courseId);
        return res.status(200).send(config.app.url+'/course-auth?rmId='+courseId+'&t=1&sKey=INSERT+SESSION+KEY+HERE');
    },
   
};  