import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import homeController from './home.controller';
import { userPermission } from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const homeRouter = express.Router();
homeRouter.route(['/', '/home']).get(jwtStrategy , userImplant ,/* userPermission('home-read') ,*/ homeController.index);
homeRouter.route(['/', '/about']).get(jwtStrategy, userImplant ,userPermission('home-read') ,homeController.about);
homeRouter.route('/guide').get(jwtStrategy, userImplant ,userPermission('home-read') ,homeController.guide);