import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import settingsController from './settings.controller';
import { userPermission } from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const settingsRouter = express.Router();
settingsRouter.route('/settings').get(jwtStrategy , userImplant,/* userPermission('setting-read') ,*/settingsController.index);
settingsRouter.route('/email').get(jwtStrategy , userImplant,/* userPermission('setting-read') ,*/ settingsController.email);
settingsRouter.route('/create-email').get(jwtStrategy, userImplant,/* userPermission('setting-read') ,*/settingsController.createEmail);
settingsRouter.route('/smtp-profile').get(jwtStrategy, userImplant,/* userPermission('setting-read') ,*/settingsController.smtpProfile);
settingsRouter.route('/create-smtp-profile').get(jwtStrategy, userImplant,/* userPermission('setting-read') ,*/ settingsController.createProfile);