'use strict';

module.exports = {
	up: (queryInterface, Sequelize) => {
		return Promise.all([
			queryInterface.addColumn(
				'MemberCourses',
				'completedAt', {
					type: Sequelize.STRING,
				},
			),
			queryInterface.addColumn(
				'MemberCourses',
				'certificateNo', {
					type: Sequelize.STRING,
				},
			), queryInterface.addColumn(
				'MemberCourses',
				'issuedDate', {
					type: Sequelize.STRING,
				},
			), queryInterface.addColumn(
				'MemberCourses',
				'isDownloaded', {
					type: Sequelize.INTEGER,
					defaultValue: 0
				},
			)
		])
	},

	down: (queryInterface, Sequelize) => {
		return Promise.all([
			queryInterface.removeColumn(
				'MemberCourses',
				'completedAt'
			), queryInterface.removeColumn(
				'MemberCourses',
				'certificateNo'
			), queryInterface.removeColumn(
				'MemberCourses',
				'issuedDate'
			), queryInterface.removeColumn(
				'MemberCourses',
				'isDownloaded'
			)
		])
	}
};
