'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn('SessionEvents', 'simulationId', {  type: Sequelize.INTEGER,	references: {  model: 'Simulations', key: 'id' },  after: "id" })
    ])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.removeColumn('SessionEvents', 'simulationId')
    ])
  }
};
