'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn(
        'Quizzes',
        'totalMarks', {
          type: Sequelize.INTEGER,
        },  queryInterface.removeColumn(
          'Campaigns',
          'quizCount'
          )
      ), 
      queryInterface.addColumn(
        'Quizzes',
        'totalQuestions', {
          type: Sequelize.INTEGER,
        },
      ), 
      queryInterface.addColumn(
        'Quizzes',
        'settings', {
          type: Sequelize.STRING,
        },
      ), 
      queryInterface.addColumn(
        'Quizzes',
        'status', {
          type: Sequelize.STRING,
        },
      ),
      queryInterface.removeColumn(
        'Quizzes',
        'duration'
      ), 
      queryInterface.removeColumn(
        'Quizzes',
        'skippable'
      )
    ])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.removeColumn(
      'Quizzes',
      'totalMarks'
      ),queryInterface.removeColumn(
        'Quizzes',
        'totalQuestions'
        ),queryInterface.removeColumn(
        'Quizzes',
        'settings'
      ),queryInterface.removeColumn(
        'Quizzes',
        'status'
      )
      ])
  }
};
