'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn(
        'MemberCourses',
        'fileName', {
          type: Sequelize.STRING,
        },
      ), 
    ])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.removeColumn(
      'MemberCourses',
      'fileName'
      )
      ])
  }
};
