'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn(
        'Courses',
        'courseType', {
          type: Sequelize.STRING,
        },
      ), 
      queryInterface.addColumn(
        'Courses',
        'instructorDetail', {
          type: Sequelize.STRING,
        },
      )
    ]);
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.removeColumn(
        'Courses',
        'courseType'
      ),
      queryInterface.removeColumn(
        'Courses',
        'instructorDetail'
      )
    ]);
  }
};
