'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
        queryInterface.addColumn(
            'Simulations',
            'executedAt',{
                type: Sequelize.DATE,
                allowNull: true,
            }
        )
    ])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
        queryInterface.removeColumn(
          'Simulations',
          'executedAt'
        )
      ]);
  }
};
