'use strict';

module.exports = {
    up: (queryInterface, Sequelize) => {
        return Promise.all([
          queryInterface.changeColumn('CourseQuizQuestions', 'title', {
              type: Sequelize.TEXT,
          }),
          queryInterface.changeColumn('CourseQuizQuestionOptions', 'title', {
              type: Sequelize.TEXT,
          }),
          queryInterface.changeColumn('CourseSectionLectures', 'name', {
            type: Sequelize.TEXT,
          }),
          queryInterface.changeColumn('CourseSections', 'name', {
            type: Sequelize.TEXT,
          }),
          queryInterface.changeColumn('QuizQuestions', 'title', {
            type: Sequelize.TEXT,
          }),
          queryInterface.changeColumn('QuizQuestionOptions', 'title', {
            type: Sequelize.TEXT,
          })
        ])
    },
    down: (queryInterface, Sequelize) => {
        return Promise.all([
          queryInterface.changeColumn('CourseQuizQuestions', 'title', {
            type: Sequelize.STRING,
          }),
          queryInterface.changeColumn('CourseQuizQuestionOptions', 'title', {
              type: Sequelize.STRING,
          }),
          queryInterface.changeColumn('CourseSectionLectures', 'name', {
            type: Sequelize.STRING,
          }),
          queryInterface.changeColumn('CourseSections', 'name', {
            type: Sequelize.STRING,
          }),
          queryInterface.changeColumn('QuizQuestions', 'title', {
            type: Sequelize.STRING,
          }),
          queryInterface.changeColumn('QuizQuestionOptions', 'title', {
            type: Sequelize.STRING,
          })
        ])
    }
};
