'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
			queryInterface.addColumn(
				'Senders',
				'requiretls', {
					  type: Sequelize.BOOLEAN,
					  defaultValue:0
				},
			)
		])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
			queryInterface.removeColumn(
				'Senders',
				'requiretls'
			)
		])
  }
};
