var sessionKey = sKey;
var quizId = id;
var memberCourseId;

var download_certificate = function() {
    api.learner.downloadCertificate({memberCourseId : memberCourseId},function (success){
        if(success && success.fileName){   
            var link=document.createElement('a');
            link.href='/static/pdf/'+success.fileName;
            link.download=success.fileName;
            link.click();
        }
    })
}

var reset_assessment  = function(){
    swal({ title: "Warning!", type: "warning", text: "Are you sure", showCancelButton: true })
    .then(function(r){
        api.learner.resetQuiz({quizId:quizId,sessionKey:sessionKey},function (success){
            if(success && success.success){   
               window.location = '/my-assessments/guidelines/'+quizId+'/'+sessionKey;
            }
        })
    })
}

$(document).ready(function(){
    api.learner.quizResult({quizId:quizId,sessionKey:sessionKey},function(success){
        $(".result_per").css("display","block")
        $(".testResult").removeClass("show").css("display","none").removeAttr("aria-modal","true").attr("aria-hidden","true");
        $(".modal-backdrop ").removeClass("show");
        $(".quiz_overview").css("display","none");
        $(".result_per").css("display","block");
        $("#scored").html(success.isCorrect * 5 +'/'+success.questionCount * 5);
        $("#attempted").html(success.answeredCount +'/'+success.questionCount);
        $("#timeSpent").html(success.memberCourse.quizTimer);
        var percentage = Math.round(success.isCorrect/success.questionCount *100);
        $("#percentage").html(percentage+"%");
        var quizSettings =  JSON.parse(success.quiz.settings);
        memberCourseId = success.memberCourse.id;
        $('#reset_quiz').hide();
        if(parseInt(percentage) >= parseInt(quizSettings.percentage)){
            $('#get_certificate').show();
            $(".failed_icon").css("display","none");
            $(".success_icon").show();
            $(".failed").css("display","none");
            $("#username").show();
            $("#resultStatus").css("color","green").html("PASS");
        }else {
            $('#get_certificate').hide();
            if(quizSettings.reset_assessment) $('#reset_quiz').show();
            $(".failed_icon").show();
            $(".success_icon").css("display","none");
            $(".failed").show();
            $("#username").css("display","none");
            $("#resultStatus").css("color","red").html("FAIL");
        }
    })
})  
