var clearAD = function(){
    $('#ssl').val('');
    $('#domainName').val('');
    $('#url').val('');
    $('#ad_username').val('');
    $('#ad_password').val('');
    $('#savePassword').prop('checked', false);
}
var senderId = 0;

var loadLogo = function() {
    api.company.get(undefined, function(success) {
        if(success && success.isSwitchAble && success.isSwitchAble["root"] && success.isSwitchAble["member"]) {
            $('#memberBox').show();
            $('#adminBox').show();
        }
        else {
            $('.userTypeBtn').off('click');
        }
        $('#home-tab').show();
        $('#profile-tab').show();
        $('#show_admin').html('');
        if(success.type == "root" || success.type == "employee"){
            $('.auth').hide();
            $('.main').show();
            $('#template-seen').hide();
            if(success.company.id == 57 || success.company.id == 260 || success.company.id == 1 || success.company.id == 71 || success.company.id == 12 || success.company.id == 466 || success.company.id == 494)
                $('#template-seen').show();
            $('#billing-head').hide();
            $('#user_roles').hide();
            $('#show_admin').html('<script type="text/javascript" > window.ZohoHCAsap=window.ZohoHCAsap||function(a,b){ZohoHCAsap[a]=b;};(function(){var d=document; var s=d.createElement("script");s.type="text/javascript";s.defer=true; s.src="https://desk.zoho.com/portal/api/web/inapp/219327000005702054?orgId=653592556"; d.getElementsByTagName("head")[0].appendChild(s); })(); </script>');
            if(success.isSwitchAble["referral"]){
                $('#user_roles').show();
                $('#billing-head').show();
            }
            $('#authBox').show();
            $('#adminRadio').prop('checked',true);
            $('#adminBox').show();
            $('#company-id').val((success.company && success.company.id ? success.company.id : ''));
            $('#company-name').val((success.company && success.company.name ? success.company.name : ''));
            (success.company && success.company.logo ?  $('#company-logo').attr('src', '/static/company/logo/'+success.company.logo) : '');
            $('#company-Id').show();
            $('#attack-profile').hide();
            $('#ad-setting').show();
            if(success.company.id == 1 || success.company.id == 57 || success.company.id == 71 || success.company.id == 93 || success.company.id == 200 || success.company.id == 260 || success.company.id == 12 || success.company.id == 466) 
                $('#attack-profile').show();
            $('#email-unsubscribe').hide();
            $('#trainingSetting').show();
            $('#'+success.company.smtpStatus+'-smtp').prop('checked', true);
            if(success.company.smtpStatus == 'custom'){
                if(success.company.id == 260 || success.company.id == 1 || success.company.id == 57)
                $('#advanced-settings').show();
                loadSender();
            } 
            $('#'+success.company.skipLogin+'-login').prop('checked', true);
            clearAD();
            if(success.company.MetaData && success.company.MetaData.length > 0){
                var adData = JSON.parse(success.company.MetaData[0].value);
                $('#ssl').val(adData.ssl);
                $('#domainName').val(adData.baseDN);
                $('#url').val(adData.url);
                $('#ad_username').val(adData.username);
                $('#ad_password').val(adData.password);
                $('#savePassword').prop('checked', adData.savePassword);
                $('#save-update-ad').html('Update');
            }
        }else{
            $('#trainingSetting').hide();
            $('.main').hide();
            $('#email-unsubscribe').hide();
            $('.auth').show();
            $('#company-Id').hide();
            $('#attack-profile').hide();
            $('#memberBox').show();
            $('#memberRadio').prop('checked',true);
        }
        if(success.company && success.company.logo){
            $('#headLogo').attr('src', '/static/company/logo/'+success.company.logo);
            $('#headLogo').addClass('logoImage');
        }else $('#headLogo').removeClass('logoImage');
    },function(error) { }, false);
}

var loadSender = function(){
    api.sender.get(undefined, function(success) {
        if(success && success.success){
            senderId = success.sender.id;
            $('#savesender').html('Update').removeAttr('disabled');
            $('#senderName').val(success.sender.name);
            $('#fromAddress').val(success.sender.fromAddress);
            $('#host').val(success.sender.host);
            $('#username').val(success.sender.username);
            if(success.sender.requiretls) $('#strattls').attr("checked", "checked");
            if(success.sender.ssl) $('#ssl').attr("checked", "checked");
            if(success.sender.pool){
                $('#pool').attr("checked", "checked");
                $('#maxmessage').val(success.sender.maxMessages);
                $('#maxconnection').val(success.sender.maxConnections);
                $('#connectiontimeout').val(success.sender.connectionTimeout);
                addPool();
            } 
            $('#limit').val(success.sender.limit);
            $('#delay').val(success.sender.delay);
            $('#add-email-headers').hide();
            $('#send-test-mail').show();
            loadHeaders(senderId);
        }else $('#headers tbody').html('No Headers');
    }, function(error) { });
}

var clearHeaders = function() {
    $('#headers tbody').html('');
}

var loadHeaders = function(senderId){
    api.header.get({senderId: senderId}, function(success) {
        clearHeaders();
        headerVal = {};
        if(success.headers && success.headers.length){
            success.headers.forEach(function(header) {
                addHeader(header);
            })
        }else{
            $('#headers tbody').html('No Headers');
        }
    });
}

var switchProfile = function(type) {
    api.company.switchProfile({type: type}, function(success){
        window.location="/";
    })
}
$(document).ready(function(){
    loadLogo();
    var theme = localStorage.getItem('Qw3d5F36');
    setTheme(theme);
    $('#redOne option').filter(function() {  
        return ($(this).val() == theme);
    }).prop('selected', true);
    $('#headName').html(page.userFirstName.charAt(0).toUpperCase());
})