import express from 'express';
import actionController from './action.controller';
import { sanitize } from '../../../middleware/sanitizer';
import { jwtStrategy } from '../../../middleware/strategy';
import { validateBody, schemas } from '../../../middleware/validator';
import { userPermission } from '../../../middleware/userPermission';

export const actionRouter = express.Router();
actionRouter.route('/actionlist/:policyId').get(sanitize(), jwtStrategy,userPermission('policy-action-read'),actionController.actionList);

 