'use strict';
module.exports = (sequelize, DataTypes) => {
  const AppsumoCode = sequelize.define('AppsumoCode', {
    name: DataTypes.STRING,
    status: DataTypes.INTEGER,
    expiredAt:DataTypes.DATE,
    userId: DataTypes.INTEGER,
  }, {
    timestamps: true,
    paranoid: true,
  });
  AppsumoCode.associate = function(models) {
    models.AppsumoCode.belongsTo(models.User, {foreignKey: 'userId'});
  };
  return AppsumoCode;
};