'use strict';
module.exports = (sequelize, DataTypes) => {
  const Content = sequelize.define('Content', {
    name: DataTypes.STRING,
    originalName: DataTypes.STRING,
    key: DataTypes.STRING,
    type: DataTypes.STRING,
    mimeType: DataTypes.STRING,
    content: DataTypes.TEXT,
    duration: DataTypes.INTEGER,
    thumbnail: DataTypes.STRING,
    companyId: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  Content.associate = function(models) {
    models.Content.hasMany(models.CourseSectionLecture , { foreignKey: 'contentId'});
  };
  return Content;
};