'use strict';
module.exports = (sequelize, DataTypes) => {
  const CourseSkill = sequelize.define('CourseSkill', {
    courseId: DataTypes.INTEGER,
    skillId: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  CourseSkill.associate = function(models) {
    models.CourseSkill.belongsTo(models.Course, {foreignKey: 'courseId'});
    models.CourseSkill.belongsTo(models.Skill, {foreignKey: 'skillId'});
  };
  return CourseSkill;
};