'use strict';
module.exports = (sequelize, DataTypes) => {
  const GroupMember = sequelize.define('GroupMember', {
    groupId: DataTypes.INTEGER,
    memberId: DataTypes.INTEGER,
    isManager: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  GroupMember.associate = function(models) {
    models.GroupMember.belongsTo(models.Group, { foreignKey: 'groupId' });
		models.GroupMember.belongsTo(models.Member, { foreignKey: 'memberId' });
  };
  return GroupMember;
};