'use strict';
module.exports = (sequelize, DataTypes) => {
  const GroupSkill = sequelize.define('GroupSkill', {
    groupId: DataTypes.INTEGER,
    skillId: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  GroupSkill.associate = function(models) {
    models.GroupSkill.belongsTo(models.Group, {foreignKey: 'groupId'});
    models.GroupSkill.belongsTo(models.Skill, {foreignKey: 'skillId'});
  };
  return GroupSkill;
};