'use strict';
module.exports = (sequelize, DataTypes) => {
  const Header = sequelize.define('Header', {
    senderId: DataTypes.INTEGER,
		key: DataTypes.STRING,
		value: DataTypes.STRING
	}, {
    timestamps: true,
		paranoid: true,
	});
  Header.associate = function(models) {
    models.Header.belongsTo(models.Sender, {foreignKey: 'senderId'});
  };
  return Header;
};