'use strict';
module.exports = (sequelize, DataTypes) => {
  const MetaData = sequelize.define('MetaData', {
    details: DataTypes.TEXT,
    companyId: DataTypes.INTEGER,
    key: DataTypes.STRING,
    value: DataTypes.TEXT
  }, {
    timestamps: true,
    paranoid: true,
  });
  MetaData.associate = function(models) {
    models.MetaData.belongsTo(models.Company, {foreignKey: 'companyId'});
  };
  return MetaData;
};