'use strict';
module.exports = (sequelize, DataTypes) => {
  const policyAction = sequelize.define('PolicyAction', {
    policyId: DataTypes.INTEGER,
    actionId: DataTypes.INTEGER
  }, {});
  policyAction.associate = function(models) {
    models.PolicyAction.belongsTo(models.Action, {foreignKey: 'actionId'});
		models.PolicyAction.belongsTo(models.Policy, {foreignKey: 'policyId'});
    
  };
  return policyAction;
};