'use strict';
module.exports = (sequelize, DataTypes) => {
  const RecentActivity = sequelize.define('RecentActivity', {
    userId: DataTypes.INTEGER,
    companyId: DataTypes.INTEGER,
    type: DataTypes.STRING,
    text: DataTypes.STRING,
    metaData: DataTypes.TEXT
  }, {
    timestamps: true,
    paranoid: true,
  });
  RecentActivity.associate = function(models) {
    // associations can be defined here
    models.RecentActivity.belongsTo(models.User, {foreignKey: 'userId'});

  };
  return RecentActivity;
};