'use strict';
module.exports = (sequelize, DataTypes) => {
  const UserPackage = sequelize.define('UserPackage', {
    companyId: DataTypes.INTEGER,
    name: DataTypes.STRING,
    value: DataTypes.STRING
  }, {
    timestamps: true,
    paranoid: true
  });
  UserPackage.associate = function(models) {
    models.UserPackage.belongsTo(models.Company, { foreignKey: 'companyId' });
  };
  return UserPackage;
};