var shouldCount = false;
var videoTime = 0;
var screenTime = 0;
var videoPlayer = null;
var lectureId = 0;
var interval = null;
var fullLecture = {};
var questionOptions = {};
var selectedOptions = {};
var isSeeking = false;
var quizOverallPercentage = 0;
var isSwithching = true;
var isBefore = false;
var percentage = 0;
var completed = {};
var lectureIds = {};
var timer = null;
var pdfCounter = 0;
var questionData = [];
var answerData = {};
var answer = {};
var setLectureCount = 0;
var currentVideoId = '';
var videoPercent = 0;
var pushLectureIds = [];
var nextVideoKey = '';
var resumeVideoPercent = '';
var resumeTime = '';
var meetingId = '';
var fullName = '';
var userStartMeeting = false;
var quizBeforeVideo = false;
var lectureType = '';

var viewDescription = function(e,desc) {
    e.preventDefault();
    $('.modal-body').html(desc);
}

var allDuration = {};
var loadlLectureList = function(name, lectures) {

    var lecturelist = '';
    if(lectures.length){
        for(var j = 0; j < lectures.length; j++){
            if(lectures[j].type != null){
                fullLecture[lectures[j].id] = lectures[j];
                if(lectures[j].type.toLowerCase() == 'video')
                    allDuration[lectures[j].id] = lectures[j].totalDuration;
                var minutes = Math.floor((lectures[j].totalDuration ? lectures[j].totalDuration: 0) / 60);
                var seconds = lectures[j].totalDuration - minutes * 60;
                var duration = minutes+':'+seconds;
                var type = '', percent = 0, lectureId = lectures[j].id;
                if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'video') type = 'file-video';
                else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'pdf')  type = 'file-pdf-o';
                else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'doc')  type = 'file-word';
                else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'ppt')  type = 'file-powerpoint';
                else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'xls')  type = 'file-excel-o';
                else type = 'question-circle';
                if(page.type == 'streaming' && lectures[j].SessionCourseLectureTrackings.length){
                    percent = lectures[j].SessionCourseLectureTrackings[0].percent;
                    videoPercent = percent;
                    resumeVideoPercent = percent;
                }
                if(page.type == 'streaming' && lectures[j].type){
                    if(currentVideoId == '')
                        currentVideoId = lectureId;
                    if(percent >=100)
                        currentVideoId = lectureId;
                    lectureIds[lectureId] = {
                        'type': lectures[j].type,
                        'lectureId': lectureId,
                        'status': percent >=100?true:false 
                    }
                }
                var descData = lectures[j].description;
                if(page.type == 'streaming' && lectures[j].type){
                    pushLectureIds.push(lectures[j].id);
                    lecturelist += '<li class="list-group-item '+(j == 0 ? 'active' : '')+'" id="lecture-'+lectures[j].id+'" name="'+videoPercent+'" onclick="checkPermission(\''+lectures[j].id+'\', \''+name+'\', \''+(lectures[j].type == 'video' ? 'video': (lectures[j].type == 'quiz' ? 'quiz' : lectures[j].type) )+'\')"> <h6 class="mb-3"><i class="fa fa-'+type+'"></i> '+lectures[j].name+'</h6><div class="row"> <div class="col-6 ">'+(lectures[j].type == 'video' ? '<p class="duration">  <i class="fa fa-clock"></i> '+toHHMMSS(lectures[j].totalDuration)+' Hrs &nbsp;</p>' : '')+'</div> <div class="col-6 "><p class="completion">Completed: <span id="percent-'+lectureId+'">'+percent+'</span> %</p></div> </div>'+(descData !=null && descData.trim() !="" ? '<button type="button" class="btn btn-outline-primary" data-toggle="modal" data-target="#exampleModal" onclick="viewDescription(e, \''+descData+'\');" style="float: right;"><i class="feather icon-file mr-2"></i>Description</button><div class="row">  </div> ' : '')+'</li>'
                    setLectureCount++;
                }else{
                    lecturelist += '<li class="list-group-item" id="lecture-'+lectures[j].id+'"> <h6 class="mb-1"> '+lectures[j].name+'</h6>'+(descData !=null  && descData.trim() !="" ? '<button type="button" class="btn btn-outline-primary" data-toggle="modal" data-target="#exampleModal" onclick="viewDescription(e, \''+descData+'\');" style="float: right;"><i class="feather icon-file mr-2"></i>Description</button><div class="row">  </div> ' : '')+'</li>'
                    setLectureCount++;
                }
            }
        }
        if(lecturelist) return lecturelist;
        else return 'No Lecture Found';
    }
    return "No Lecture Found";
}

var stopLecture = function()  {
    if (videoPlayer)
        videoPlayer.pause();
    goodbye();
}

var showBefore = function(lectureId) {
    var status = true;  
    Object.keys(lectureIds).forEach(function(lecture){
        if((lectureIds[currentVideoId]['status'] == true)){
            for(var index in pushLectureIds) {
                if(pushLectureIds[index] == currentVideoId){
                    nextVideoKey = parseInt(index)+1;
                }                
            }
        }
        if((lectureIds[lectureId]['type']) && (lectureIds[lectureId]['status'] == false) && (parseInt(lecture) < parseInt(lectureId))){
            status = false
        } 
        if(pushLectureIds[nextVideoKey] == lectureId ){
            status = true
        }
    })
    return status;
}

var checkPermission = function(lecture, name, type) {
 //  loadContent(lecture, name, type,videoPercent);
    $('.list-group-item').removeClass('active');
    $('#lecture-'+lecture).addClass('active');
    videoPercent = $('#lecture-'+lecture).attr('name');
    resumeVideoPercent = videoPercent;
    if(type == 'quiz' && quizBeforeVideo){
        if(videoPlayer != null) videoPlayer.pause();
        loadContent(lecture, name, type,videoPercent);
        currentVideoId = lecture;   
    }else {
        if(isSwithching || showBefore(lecture)){
            if(type == 'quiz' && videoPlayer != null ) videoPlayer.pause();
            loadContent(lecture, name, type,videoPercent);
            currentVideoId = lecture;
        }else {
            clearErrors();
            if(videoPlayer != null) videoPlayer.pause();
            showError("You don't have permission to skip lecture !");
        }
    }
}
var hideSideBar=function(){
    $('#course-preview .left-sidebar').fadeOut();
    $('.col-sm-9.right-content').css({"width":"100%","flex": "0 0 100%","max-width": "100%"})
    $('.show-toggle').show();
}
var showSideBar = function(){
    $('#course-preview .left-sidebar').fadeIn();
    $('.col-sm-9.right-content').css({"width":"100%","flex": "0 0 75%","max-width": "75%"})
    $('.show-toggle').hide();
}
var show = function(msg) {
    $('#error').html(msg);
    $('#error').show();
    setTimeout(function(){
        $('#error').hide();
    }, 4000)
}


var pdfTrack = function() {
    clearTimer();
    timer = setInterval(function () {
        pdfCounter++;
        if(pdfCounter >= 10){
            goodbye();
            clearTimer();
        }
    }, 1000);
}

var trackingOneMin = function() {
    clearTimer();
    timer = setInterval(function () {
        goodbye();
    }, 10000);
}

var currentTime = 0;

var playVideo = function(restartTime,videoPercent) {
    if(videoPercent != 100)
        videoPlayer.currentTime(restartTime).play();
    else
        videoPlayer.currentTime(0).play();
}

var renderVideo = function(restartTime,videoPercent) {
    resumeVideoPercent = videoPercent;
    videojs(document.getElementById('video1'), {}, function() {
        videoPlayer = this;
        if(videoPercent != 100)
            this.currentTime(restartTime).play();
        else this.play();

        this.on('play', function () {
            shouldCount = true;
        });

        this.on('ended', function () {
            shouldCount = false;
            goodbye();
        });

        this.on('pause', function () {
            shouldCount = false;
        });

         this.on("seeking", function (event) {
            if(!isSeeking){
                if (currentTime < videoPlayer.currentTime()) {
                    if(resumeVideoPercent != 100)
                        videoPlayer.currentTime(resumeTime).play();
                    else
                        videoPlayer.play();
                }
            }
         });

         this.on("seeked", function (event) {
            if(!isSeeking){
                if (currentTime < videoPlayer.currentTime()) {
                   if(resumeVideoPercent != 100)
                        videoPlayer.currentTime(resumeTime).play();
                    else
                        videoPlayer.play();
                }
            }
         });

        interval = setInterval(function () {
            if (!videoPlayer.paused()) {
                currentTime = videoPlayer.currentTime();
            }
        }, 1000);
    });
}

var download_certificate = function(memberCourseId) {
    api.learner.downloadCertificate({memberCourseId : memberCourseId},function (success){
         if(success && success.fileName){   
              var link=document.createElement('a');
              link.href='/static/pdf/'+success.fileName;
              link.download=success.fileName;
              link.click();
          }
    })
}

var setDownload = function(memberCourseId) {
    $("#downloadId").html('');
    $("#downloadId").html('<a href="#" onclick="download_certificate('+memberCourseId+')" class="btn btn-primary">Get Certificate <i class="feather icon-download"></i></a>')
}


var goodbye = function (e) {
    var type = $('#file-type').val();
    if(type == 'video' || type == 'pdf' || type == 'doc' || type == 'ppt' || type == 'xls'){
        resumeTime = (type == 'video' ? videoPlayer.currentTime() : 60);
        var data = {
            "duration": (type == 'video' ? videoPlayer.currentTime() : 60),
            "courseSectionLectureId": lectureId,
            "courseId": page.courseId
        };
        api.course.tracker(data, function (success) {
            $('#percent-'+lectureId).html(success.percent);
            $('#lecture-'+lectureId).attr('name',success.percent);
            if(success.percent >= 100){
                lectureIds[lectureId]['status'] = true;
                clearTimer();
            }
            if(success.coursePercentage == 100){
                setDownload(success.memberCourseId);
            }
        }, function (error) { }, false);
    }
}

var restartQuiz = function(lectureId){
    swal({ title: 'Are you sure?',  text: "You want to restart quiz", type: 'warning', showCancelButton: true, confirmButtonClass: 'btn  btn-success', cancelButtonClass: 'btn btn-danger m-l-10'})
    .then(function () {
        api.member.restartCourseQuiz({lectureId:lectureId, sessionKey:page.sKey}, function(success){
            if(success && success.success){
                $('#quiz').html('<div class="question_combine" id="course-questions"> </div>');
                fullLecture[lectureId].CourseUserQuizDetails = [];
                loadQuiz(lectureId, success.result);
                $('#percent-'+lectureId).text(0);
                if(success.coursePercentage < 100){
                    $("#downloadId").html('');
                }
            }
        }, function(error) {})
    });
}

var validateUserSubmitQuiz = function(lectureId){
    clearErrors();
    var data = new Object();
    data.lectureId = lectureId;
    data.sessionKey = page.sKey;
    data.courseId = page.courseId;
    var results = [];
    $(".get_checked").each(function() {
        if($(this).prop("checked"))
            results.push({"questionId":$(this).attr("q-id"), "optionId":$(this).attr("opt-id")});
    });
    // if(questionc != results.length)
    //     addError('a', 'Correct answers are required for all questions.');
    data.results = JSON.stringify(results);
    hasError() && showErrors();
    return data;
}

var submitQuiz = function(lectureId){
    var data = validateUserSubmitQuiz(lectureId);
    console.log(data)
    !hasError() && api.member.submitCourseQuiz(data, function(success){
        if(success && success.success){
            fullLecture[lectureId].CourseUserQuizDetails.push({ "percent": success.percent, "status" : 1});
            passFailStatus(lectureId, success.percent);
            $('#percent-'+lectureId).text(Math.round(success.percent));
            if(success.coursePercentage == 100){
                setDownload(success.memberCourseId);
            }
        }
    }, function (error) {})
}
var loadQuizQuestionOption = function(qId, option){
    $('#question-option-'+qId).append('<div class="custom-control custom-radio quuiz_box"> <input type="radio" id="customRadio-'+option.id+'" name="customRadio-'+qId+'" class="custom-control-input get_checked" q-id="'+qId+'" opt-id="'+option.id+'"> <label class="custom-control-label" for="customRadio-'+option.id+'">'+option.title+'</label> </div>');
}

var loadQuizQuestion = function(z, question){
    $('#course-questions').append('<div class="question_nameLer"> <h5>Question '+z+'</h5> <hr> <div class="question_title"> <h6>'+question.title+'?</h6> '+(question && question.thumbnail ? '<img src="/static/course/content/thumbnail/'+question.thumbnail+'" class="img-fluid">' : '')+' <div class="optionname" id="question-option-'+question.id+'">  </div> </div> </div>');
    if(question.CourseQuizQuestionOptions && question.CourseQuizQuestionOptions.length > 0){
        question.CourseQuizQuestionOptions.forEach(function(option)  {
            loadQuizQuestionOption(question.id, option);
        });
    }
}

var questionc = 0;
var loadQuiz = function(lectureId, lectureData){
    $('#all-hide-overview').hide();
    $('#videotitle').hide();
    $('#videodesc').hide();
    $('#submitquiz').show();
    $('#quiz').html('').html(' <div class="question_combine" id="course-questions"> </div>');
    if(lectureData && lectureData.length){
        var data = lectureData;
        questionData = [];
        questionc = data.length;
        for(z = 0; z < data.length; z++){
            if(data[z] && data[z].CourseQuizQuestion){
                loadQuizQuestion((z + 1), data[z].CourseQuizQuestion); 
                questionData.push(data[z]);     
            }
        }
    }
    $('#quiz').append('<div class="question_quiz_sub" onclick="submitQuiz('+lectureId+');" id="submitquiz"> <button type="button" class="btn btn-success">Submit</button> </div>');
}

var passFailStatus = function(lectureId, percent){
    $('#all-hide-overview').show();
    $('#videotitle').show();
    $('#videodesc').show();
    $('#quiz').html('');
    if(parseInt(quizOverallPercentage) <= Math.round(percent)){
        $('#quiz').html('<div class="pasesd_status" id="pass"> <div class="passed_fail"> <div class="passed_per" style="background-color: #00cc66;"> <h5 class="green_pass">'+Math.round(percent)+'%</h5> <p>Test Score</p> </div> </div> <div class="text_passed"> <h5>Congratulations, you passesd</h5> <p>Thank you for submitting your quiz</p>  <a href="/quiz-results?lId='+lectureId+'&sKey='+page.sKey+'" class="btn btn-primary"  target="_blank">View Result</a> </div> </div>');
    }else{
        $('#quiz').html('<div class="pasesd_status" id="fail"> <div class="passed_fail"> <div class="passed_per" style="background-color: red;"> <h5 class="green_pass">'+Math.round(percent)+'%</h5> <p>Test Score</p> </div> </div> <div class="text_passed"> <h5>Sorry, You are failed</h5> <p>Thank you for submitting your quiz</p> <button type="button" class="btn btn-primary" onclick="restartQuiz('+lectureId+')">Restart Quiz</button>  <a href="/quiz-results?lId='+lectureId+'&sKey='+page.sKey+'" class="btn btn-primary" target="_blank">View Result</a> </div> </div>');
    }
}

var loadFileUsingType = function(type, lectureData) {
    if(type == 'video' && lectureData){       
        $('#video1').attr('src', (lectureData.name ? '/video/'+lectureData.name : "/webnair.mp4"));
        $('#video1_html5_api').attr('src', (lectureData.name? '/video/'+lectureData.name :"/webnair.mp4"));
        $('#video1').show();
    }else if(type == 'pdf' && lectureData){
        $('#iframe11').attr('src', (lectureData.name? '/static/course/content/'+lectureData.name+'#toolbar=0' :"http://pdfviewer.softgateon.net/"));
        $('#pdf').show();
    }else if((type == 'doc' || type == 'ppt' || type == 'xls') && lectureData){
        $('#iframe11').attr('src', (lectureData.name? 'https://view.officeapps.live.com/op/embed.aspx?src='+window.origin+'/static/course/content/'+lectureData.name :"http://pdfviewer.softgateon.net/"));
        $('#pdf').show();
    }else{
        if(lectureData && lectureData.CourseUserQuizDetails){
            var d = lectureData.CourseUserQuizDetails[0];
            if(d && d.status) passFailStatus(lectureData.id, d.percent)
            else loadQuiz(lectureData.id, lectureData.CourseLectureQuestions);
        }else loadQuiz(lectureData.id, lectureData.CourseLectureQuestions);
        $('#quiz').show();
    }
}

var clearContent = function() {
    $('#sectionname').text('');
    $('#video1').hide();
    $('#pdf').hide();
    $('#quiz').hide();
    $('#video1_html5_api').removeAttr('src');
    $('#iframe11').removeAttr('src');
    $('#course-questions').html('');
    $('.optionname').html('');
    $('#file-type').val('');
    $('#videotitle').text('').show();
    $('#videodesc').text('').show();
    $('#submitquiz').hide();
    $('#all-hide-overview').show();
}

var clearTimer = function() {
    clearInterval(timer);
    timer = null;
}

var loadContent = function(id, sectionname, type,videoPercent) {
    clearTimer();
    clearContent();
    lectureId = id;
   //videoPlayer = null;
    var lectureData = fullLecture[lectureId];
    restartTime = 0;
    restartTime = lectureData.totalDuration * videoPercent/100;
    resumeTime = restartTime;
    // if(lectureData.user_lecture_trackings && lectureData.user_lecture_trackings && lectureData.user_lecture_trackings[0].percentage == 100){
    //     console.log(lectureData.user_lecture_trackings[0].percentage);
    // }
    // if(lectureData.user_lecture_trackings && lectureData.user_lecture_trackings[0] && lectureData.user_lecture_trackings[0].duration < lectureData.duration){
    //     currentTime = (lectureData.user_lecture_trackings[0].duration - 1);
    // }
    if(type == 'video') {
        loadFileUsingType(type, lectureData.Content);
        goodbye();
        videoTime = 0;
        renderVideo(restartTime,videoPercent);
        trackingOneMin();
        playVideo(restartTime,videoPercent);
    }else if(type == 'pdf' || type == 'doc' || type == 'ppt' || type == 'xls') {
        loadFileUsingType(type, lectureData.Content);
        stopLecture()
        pdfCounter = 0;
        pdfTrack();
    }else {
        loadFileUsingType(type, lectureData);
    }
    $('#file-type').val(type);
    $('#sectionname').text(sectionname);
    $('#videotitle').text(lectureData.title);
}

var loadSectionList = function(idx, section) {
    var lectures = section.CourseSectionLectures;
    if(section.CourseSectionLectures.length > 0){
        $('#sectionlist').append('<div class="card"> <a data-toggle="collapse" data-target="#collapse'+idx+'"> <div class="card-header" id="headingOne"> <h5 class="mb-0"> Section '+idx+' : '+section.name+'</h5> </div> </a> <div id="collapse'+idx+'" class="collapse '+(idx == 1 ? 'show': '')+'" aria-labelledby="headingOne" data-parent="#accordion"> <div class="card-body"> <ul class="list-group list-group-flush"> '+loadlLectureList(section.name, lectures)+'</ul> </div> </div> </div>')
    }
}

function stopInt() {
    clearInterval(myVar);
}

function autoStartMeeting(){
    if(countMeeting == 0){
        var URL = "https://meet.krademylms.com/bigbluebutton/api/join?fullName="+fullName+"&meetingID="+meetingId+"&password=ap&redirect=true&checksum="+page.urlKey;
        $('#open_url').attr('href', URL);
        $('#open_url')[0].click();
        countMeeting = 1;
        $('#hide_join_meeting').show();
        $('#show_meeting_not_started').hide();
        userStartMeeting = true;
        $('#clearInterval')[0].click();
    }
}

var countMeeting = 0;
function isRunningStartMeeting(showloader){
    if(showloader) showloader = true;
    else showloader = false;
    api.auth.isMeetingRunning({meetingId: meetingId, courseId: page.courseId}, function(success){
        if(success && success.expired){
            $('#show_meeting_expired').show();
            $('#hide_join_meeting').hide();
            $('#show_meeting_not_started').hide();
        }else if(success && success.running == "true"){
            autoStartMeeting();
        }else{
            $('#hide_join_meeting').hide();
            $('#show_meeting_not_started').show();
            countMeeting = 0;
        }
    }, function (error){}, showloader)
}

var myVar = null;
function joimMeetingUser(){
    if(!userStartMeeting){
        isRunningStartMeeting(true);
        myVar = setInterval(isRunningStartMeeting, 10000);
    }else{
        var URL = "https://meet.krademylms.com/bigbluebutton/api/join?fullName="+fullName+"&meetingID="+meetingId+"&password=ap&redirect=true&checksum="+page.urlKey;
        window.open(URL, '_blank');
        $('#clearInterval')[0].click();
    }
}

var clearSectionList = function() {
    $('#sectionlist').html('');
    $('#lecturelist').html('');
    $('#coursename').html('');
    $('#course_name').html('');
    $('.page-title').html('');
    $('.show_description').html('');
    $('.show_course_skills').html('');
    $('.show_lang').html('');
    $('.show_lecture_count').html('');
    $('#meet_date').html('');
    $('#meet_time').html('');
    $('#meet_duration').html('');
}

var loadSectionLectures = function(){ 
    var skills = []; var skillname = '';
    api.course.getMemberCourse({id: page.courseId, sKey: page.sKey}, function(success){
        if(success){
            if(parseInt(success.coursePercent) == 100 ){
                setDownload(success.memberCourseId);
            }
            clearSectionList();
            if(success && success.course){
                if(success.course.CourseSkills && success.course.CourseSkills.length > 0){
                    success.course.CourseSkills.forEach(function(skill)  {
                        skillname = skill.Skill.name;
                        skills.push(skillname);
                    });
                }
                var settings = (success.course.setting ? JSON.parse(success.course.setting) : undefined)
                isSwithching = (settings && settings.hasOwnProperty('lecture_switching') ? settings.lecture_switching : true);   
                isSeeking = ( settings && settings.hasOwnProperty('video_seeking') ? settings.video_seeking : false); 
                quizOverallPercentage = ( settings && settings.hasOwnProperty('quiz_passing_percentage') ? settings.quiz_passing_percentage : 0); 
                quizBeforeVideo = ( settings && settings.hasOwnProperty('quiz_before_video') ? settings.quiz_before_video : false); 
                $('#coursename').html(success.course.name);
                $('.course_name').html(success.course.name);
                $(".page-title").html('Course: '+success.course.name);
                if(success.course.description){
                    $('.p_desc').css('display','block')
                    $('.show_description').html(success.course.description);
                }
                $('.show_course_skills').html(skills.toString());
                $('.show_lang').html(success.course.Language.name);
                if(success.course && success.course.instructorDetail){
                    var instrutor_meta = JSON.parse(success.course.instructorDetail)
                    $('#meet_date').html(instrutor_meta.date);
                    $('#meet_time').html(instrutor_meta.time);
                    $('#meet_duration').html(instrutor_meta.duration);
                    if(instrutor_meta.expired){
                        $('#hide_join_meeting').hide();
                        $('#show_meeting_not_started').hide();
                        $('#show_meeting_expired').show();
                    }
                    meetingId = instrutor_meta.meetingId;
                    fullName = success.userName;
                    userStartMeeting = ( settings && settings.hasOwnProperty('userStartMeeting') ? settings.userStartMeeting : false);
                }
                if(success.course.CourseSections){
                    var section = success.course.CourseSections;
                    for(var i = 0; i < section.length; i++){
                        loadSectionList((i+1), section[i]);
                    }
                    if(page.type == 'streaming' && section[0] && section[0].CourseSectionLectures && section[0].CourseSectionLectures[0]){
                        var data = section[0].CourseSectionLectures[0];
                        loadContent(data.id, section[0].name,  data.type.toLowerCase(), (data.SessionCourseLectureTrackings.length ? data.SessionCourseLectureTrackings[0].percent : 0))
                    }
                    $('.show_lecture_count').html(setLectureCount);
                }
            }
        }
    })
}

function timeInactivity(mins){
    if(mins == 0 || mins < 5) return 120000;
    if(mins == 5 || mins < 10) return 240000;
    if(mins == 10 || mins < 15) return 300000;
    if(mins == 15 || mins < 20) return 360000;
    if(mins == 20 || mins < 25) return 480000;
    if(mins == 25 || mins < 30) return 540000;
    if(mins == 30 || mins < 35) return 660000;
    if(mins == 35 || mins < 40) return 720000;
    if(mins == 40 || mins < 45) return 780000;
    if(mins == 45 || mins < 50) return 900000;
    if(mins == 50 || mins < 60) return 1020000;
    if(mins >= 60) return 1200000;
}

var timeoutId;
  
function startTimer() { 
    var type = $('#file-type').val();
    if(type == 'video'){
        if($('.list-group-item').hasClass('active')){
            var mainLId = $('.list-group-item.active').attr('id').split('-');
            var lectureDur = allDuration[mainLId[1]];
            var timeoutInMiliseconds = timeInactivity(Math.floor(lectureDur / 60) % 60);
            timeoutId = window.setTimeout(doInactive, timeoutInMiliseconds)
        }
    }
}

function resumeLectureWatching(){
    $('#modalShow').modal('hide');
    videoPlayer.play();
}

function doInactive() {
    var type = $('#file-type').val();
    if(type == 'video'){
        if(!videoPlayer.paused()){
            $('#modalShow').modal({ backdrop: 'static', keyboard: false}); 
            videoPlayer.pause();
        }
    }
}
 
function setupTimers () {
    document.addEventListener("mousemove", resetTimer, false);
    document.addEventListener("mousedown", resetTimer, false);
    document.addEventListener("keypress", resetTimer, false);
    document.addEventListener("touchmove", resetTimer, false);
    startTimer();
}

function resetTimer() { 
    window.clearTimeout(timeoutId)
    startTimer();
}


var S3fe43dG = function() {
    $('#video1').bind('contextmenu',function() { return false; });
    window.onload = function() {
        document.addEventListener("contextmenu", function(e){
          e.preventDefault();
        }, false);
        document.addEventListener("keydown", function(e) {
            if (e.ctrlKey && e.shiftKey && e.keyCode == 73) 
                disabledEvent(e);
            if (e.ctrlKey && e.shiftKey && e.keyCode == 74) 
                disabledEvent(e);
            if (e.keyCode == 83 && (navigator.platform.match("Mac") ? e.metaKey : e.ctrlKey)) 
                disabledEvent(e);
            if (e.ctrlKey && e.keyCode == 85) 
                disabledEvent(e);
            if (event.keyCode == 123) 
                disabledEvent(e);
        }, false);
        function disabledEvent(e){
            if (e.stopPropagation)
                e.stopPropagation();
            else if (window.event)
                window.event.cancelBubble = true;
            e.preventDefault();
            return false;
        }
    };
}

var acceptCourseGuidelines = function(){
    clearErrors();
    var ckeckValue = document.getElementById("check_val").checked;
    if(ckeckValue !=true){
         addError('check', 'Please accept terms & conditions first');
         hasError() && showErrors();
    }else{
        $('#modalCousreStart').modal('hide');
        loadSectionLectures();
    }
}

var copyToClipboardLeaner = function(){
    var allUrl = window.location.origin+'/course-auth?rmId='+page.rmId+'&t=1&sKey='+page.sKey;
    var Url = document.getElementById("copy-url");
    Url.value = allUrl;
    Url.select();
    document.execCommand("copy");
    $('#set-title').removeAttr('data-original-title').attr('data-original-title', 'Copied!');
}

var blurred = false;
window.onblur = function() { blurred = true; };
window.onfocus = function() { blurred && (isRunningStartMeeting(false))}; 
window.onblur = function() { doInactive() };
$(document).ready(function() {
    S3fe43dG();
    $('#copyUrl').modal('hide');
    var isIE = /*@cc_on!@*/false || !!document.documentMode;
    // Edge 20+
    var isEdge = !isIE && !!window.StyleMedia;
    // var isChrome = !!window.chrome && (!!window.chrome.webstore || !!window.chrome.runtime);
    if(isEdge && page.rmId != ""){
        $('#copyUrl').modal('show');
        var allUrl = window.location.origin+'/course-auth?rmId='+page.rmId+'&t=1&sKey='+page.sKey;
        var Url = document.getElementById("copy-url");
        Url.value = allUrl;
    }
    // $('#modalCousreStart').modal('hide');
    // if(parseFloat(page.qWE34sT) == 0.00){
    //     $('#modalCousreStart').modal('show');
    //     $('#modalCousreStart').modal({backdrop: 'static', keyboard: false}) 
    // }
    // if(!($("#modalCousreStart").data('bs.modal') || {})._isShown)
        loadSectionLectures();
    if(page.type == 'streaming'){
        $('#streaming').show();
        window.onbeforeunload=goodbye;
        setupTimers();
    } else $('#instructorled').show(); 
    
    // var frame = document.getElementById("iframe11"),
    // frameDoc = frame.contentDocument || frame.contentWindow.document;
    // $(frameDoc).ready(function() {
    //     console.log('load iframe')
    //     // $('#m_excelEmbedRenderer_m_ewaEmbedViewerBar').remove();
    //     setInterval(function(){ 
    //         console.log('load iframe in setinterval')
    //         $('#iframe11').contents().find('#m_excelEmbedRenderer_m_backstageAnchor').remove();
    //         $('#m_excelEmbedRenderer_m_backstageAnchor').remove();
    //         // var elem = frameDoc.getElementById("m_excelEmbedRenderer_m_backstageAnchor");
    //         // elem.remove();
    //         // var eld = frameDoc.getElementById("m_excelEmbedRenderer_m_feedbackAnchor");
    //         // eld.remove();
    //         // $('.cui-toolbar-button-right').remove();
    //         // $('.clip22x22').remove();
    //         // $('#m_excelEmbedRenderer_m_backstageAnchor').remove();
    //         // $('#m_excelEmbedRenderer_m_feedbackAnchor').remove();
    //     }, 15000);
    // });
});