var reloadList = function () {
    load();
}

function addTemplate(temp, i, metadata){
    var status = 'Default';
    var subject = temp.subject;
    if(metadata.length > 0){
        metadata.forEach(function(meta){
            var data = JSON.parse(meta.value);
            if(data.enable && meta.key == temp.name){
                status = 'Custom ('+capitalizeFirstLetter(data.type)+')';
                subject = data.subject;
            }
        })
    }
    $('#template-list').append('<tr> <td> <h6>'+i+'</h6> </td> <td style="width:300px">  <a href="/template/edit/'+temp.id+'"><h6><span class="skill_list">'+temp.name+'</span></h6> </a></td><td> <h6>'+status+'</h6> </td>  <td> <h6>'+subject+' </h6> </td> <td><a href="/template/edit/'+temp.id+'" data-toggle="tooltip" data-placement="top" title="" data-original-title="Edit" class="btn btn-round btn-warning-rgba icon_temp" ><i class="feather icon-edit"></i></a></td> </tr>')
}

function validate() {
    var data = new Object();
    data.page = getPageNo();
    data.limit = getLimit();
    return data;
}

function clearTemplate(){
    $('#template-list').html('');
}

function load(){
    var data = validate();
    api.template.list(data, function(success) {
        if(success &&  success.templates.length > 0){
            clearTemplate();
            var i = 1;
            success.templates.forEach(function(template) {
                addTemplate(template, i, success.metadata);
                ++i;
            });
            if (success.count > 0){
                $('#paginate').show();
                addPagination(success.pages, success.count);
            }
        }else $('#template-list').html('No Template found.')
    });
}

$(document).ready(function(){
    load();
})