function query(e, t, n, r, success, error, showError, noloader, noshow, noAPIerror) {
    if(showError == undefined) showError = true;
    if(noloader == undefined) noloader =  true;
    if(noshow == undefined) noshow =  true;
    if(noAPIerror == undefined) noAPIerror =  true;
    if (typeof mprogress != 'undefined') {
        mprogress.start();
    }
    if(noloader == true)
        $('#loader-wrap').show();
    var params = {}
    if (t == 'GET' && n != undefined) {
        params = $.extend({}, params, n);
        n = undefined;
    }
    return $.ajax({
        url: "/api" + e + "?" + jQuery.param(params),
        async: r,
        method: t,
        data: n != undefined ? JSON.stringify(n) : '',
        dataType: "json",
        contentType: "application/json",
        success: function (msg) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            if(noloader == true)
                $('#loader-wrap').hide();
            success(msg);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            if(noloader == true)
                $('#loader-wrap').hide();
            if (noshow && showError)
                if(noAPIerror)
                    showAPIError(jqXHR.status, (jqXHR.responseJSON ? jqXHR.responseJSON : (jqXHR.responseText === "Unauthorized" ? { errors: ['Invalid Credentials'] } : jqXHR.responseText)));
            if (error != undefined) error(jqXHR.responseJSON);
        }
    })
}

function mediaQuery(e, t, n, r, success, error) {
    if (typeof mprogress != 'undefined') {
        mprogress.start();
    }
    return $.ajax({
        url: "/api" + e,
        async: r,
        method: t,
        data: n != undefined ? n : '',
        processData: false,
        contentType: false,
        success: function (msg) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            $('#loader-wrap').hide();
            success(msg);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            $('#loader-wrap').hide();
            showAPIError(jqXHR.status, (jqXHR.responseJSON ? jqXHR.responseJSON : (jqXHR.responseText === "Unauthorized" ? { errors: ['Invalid Credentials'] } : jqXHR.responseText)));
            if (error != undefined) error(jqXHR.responseJSON);
        }
    })
}

function queryURL(e, t, n, r, success, error) {
    if (typeof mprogress != 'undefined') {
        mprogress.start();
    }
    return $.ajax({
        xhr: function () {
            var xhr = new window.XMLHttpRequest();
            var lectureId = n.get('lectureId');
            var addedId = n.get('addedId');
            var fileAll = n.get('filename');
            var ext = fileAll.name.split('.').pop().toLowerCase();
            if(ext == 'pdf' || ext == 'doc' || ext == 'docx'|| ext == 'ppt' || ext == 'pptx' || ext == 'xlsx' || ext == 'xls' || ext == 'mp4'){
                if(addedId != 0)
                    lectureId = addedId;
                    $('body').removeClass('modal-open');
                    $(".modal-backdrop").remove();
                    $("#videoModal").modal('hide');
                    $("#videoModal").removeClass("show").css('display','none');
                    $('#pdfModal').modal('hide');
                    $("#pdfModal").removeClass("show").css('display','none');
                    $('.new-div-' + lectureId + '').css('display', 'block');
                    $('#vp-'+lectureId).css({"display":"none"});
                    $('#progress-'+lectureId).show();
                    $('#editFile-'+lectureId).hide();
                    $("#lname-" + lectureId + "").text(uploadedFileName);
                    if(vidImgSrc != ''){
                        $('#img-' + lectureId + '').attr("src", vidImgSrc);
                        $("#duration-" + lectureId + "").text(toHHMMSS(duration));
                    }
                    // else
                    //     $('#img-' + lectureId + '').attr("src", "/static/course/content/thumbnail/pdf.jpeg");
                xhr.upload.addEventListener("progress", function (evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = evt.loaded / evt.total;
                        $('.running-ajax-upload').css({ width: percentComplete * 100 + '%' }).html(Math.ceil(percentComplete * 100)+ '%');
                        if (percentComplete === 1) {
                            $('#progress-'+lectureId).hide();
                            $('.running-ajax-upload').css({ width: '0%' });
                            $('#editFile-'+lectureId).show();
                            $('#vp-'+lectureId).css({"display":"inline-block"});
                        }
                    }
                }, false);
            }
            return xhr;
        },
        url: "/api" + e,
        async: r,
        method: t,
        data: n != undefined ? n : '',
        processData: false,
        contentType: false,
        success: function (msg) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            success(msg);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            showAPIError(jqXHR.status, (jqXHR.responseJSON ? jqXHR.responseJSON : (jqXHR.responseText === "Unauthorized" ? { errors: ['Invalid Credentials'] } : jqXHR.responseText)));
            if (error != undefined) error(jqXHR.responseJSON);
        }
    })
}
function dataQuery(e, t, n, tableId, column_data) {
    var dataArr = [];
    var params = {}
    if (t == 'GET' && n != undefined) {
        params = $.extend({}, params, n);
        n = undefined;
    }
    return $('#' + tableId).DataTable({
        "ajax": {
            url: "/api" + e + "?" + jQuery.param(params),
        },
        "rowCallback": function (nRow, cssaData, iDisplayIndex) {
            $('#' + tableId).show();
            var oSettings = this.fnSettings();
            $("td:first", nRow).html(oSettings._iDisplayStart + iDisplayIndex + 1);
            return nRow;
        },
        "columns": column_data,
        "bDestroy": true


    });



}
var api = {
    appsumo: {
        post: function (data, success, error) {
            return query('/appsumo/', "POST", data, 1, success, error)
        },
    },
    auth: {
        post: function (data, success, error) {
            return query('/auth/register/', "POST", data, 1, success, error)
        },
        free: function (data, success, error) {
            return query('/auth/free-trial/', "POST", data, 1, success, error)
        },
        user: function (data, success, error) {
            return query('/auth/user/', "POST", data, 1, success, error, false)
        },
        login: function (data, success, error) {
            return query('/auth/login/', "POST", data, 1, success, error, true, true, true, false)
        },
        changePassword: function (data, success, error) {
            return query('/auth/changePassword/', "POST", data, 1, success, error)
        },
        setPassword: function (data, success, error) {
            return query('/auth/setPassword/', "POST", data, 1, success, error, true, true, true, false)
        },
        sendReset: function (data, success, error) {
            return query('/auth/sendReset/', "POST", data, 1, success, error)
        },
        resetPassword: function (data, success, error) {
            return query('/auth/reset/', "POST", data, 1, success, error)
        },
        isMeetingRunning: function (data, success, error, noloader) {
            return query('/auth/ismeetingrunning/', "GET", data, 1, success, error, true, noloader)
        },
    },

    home: {
        get: function (data, success, error) {
            return query('/dashboard/', "GET", data, 1, success, error, true)
        },
        types: function (data, success, error) {
            return query('/dashboard/campaign-types', "GET", data, 1, success, error, true)
        },
        graph: function (data, success, error) {
            return query('/dashboard/graph', "GET", data, 1, success, error, true)
        },
        activity: function (data, success, error){
            return query('/dashboard/activity', "GET", data, 1, success, error, true)
        },
        topCourses: function (data, success, error){
            return query('/dashboard/top-courses', "GET", data, 1, success, error, true)
        },
        activityLog: function (data, success, error){
            return query('/dashboard/activity-log', "GET", data, 1, success, error, true)
        },
    },

    group: {
        get: function (data, success, error, noloader) {
            return query('/group/', "GET", data, 1, success, error, true ,noloader)
        },
        checkAD: function (data, success, error, noloader) {
            return query('/group/check/AD', "POST", data, 1, success, error, true ,noloader)
        },
        password: function (data, success, error, noloader) {
            return query('/group/AD/password', "POST", data, 1, success, error, true ,noloader)
        },
        createUserGroups: function (data, success, error, noloader) {
            return query('/group/active-directory/user-groups', "POST", data, 1, success, error, true ,noloader)
        },
        fetch: function (data, success, error, noloader) {
            return query('/group/active/directory/groups', "GET", data, 1, success, error, true ,noloader)
        },
        users: function (data, success, error, noloader) {
            return query('/group/active/directory/users', "GET", data, 1, success, error, true ,noloader)
        },
        existing: function (data, success, error) {
            return query('/group/existing/group', "GET", data, 1, success, error)
        },
        post: function (data, success, error) {
            return mediaQuery('/group/', "POST", data, 1, success, error)
        },
        check: function (data, success, error) {
            return mediaQuery('/group/check', "POST", data, 1, success, error, true)
        },
        hierarchyData: function (data, success, error) {
            return query('/group/hierarchy/data/department', "GET", data, 1, success, error)
        },
    },

    groupId: {
        get: function (id, data, success, error) {
            return query('/group/' + id + '/', "GET", data, 1, success, error)
        },
        patch: function (id, data, success, error) {
            return mediaQuery('/group/' + id + '/', "PATCH", data, 1, success, error)
        },
        count: function (id, data, success, error) {
            return query('/group/sub/group/' + id, "GET", data, 1, success, error)
        },
        delete: function (id, data, success, error) {
            return query('/group/' + id + '/', "DELETE", data, 1, success, error)
        },
    },

    member: {
        get: function (data, success, error, noloader) {
            return query('/member/', "GET", data, 1, success, error, true, noloader)
        },
        submitCourseQuiz: function (data, success, error) {
            return query('/member/', "POST", data, 1, success, error)
        },
        restartCourseQuiz: function (data, success, error) {
            return query('/member/restart-quiz/', "GET", data, 1, success, error);
        },
        emailUnsubscribe: function (data, success, error) {
            return query('/member/email/unsubscribe/', "GET", data, 1, success, error);
        },
        saveEmailUnsubscribe: function (data, success, error) {
            return query('/member/save/emailUnsubscribe/', "POST", data, 1, success, error);
        },
    },

    course: {
        get: function (data, success, error) {
            return query('/course/', "GET", data, 1, success, error);
        },
        getMemberCourse: function (data, success, error) {
            return query('/course/member-course', "GET", data, 1, success, error);
        },
        previewCourse: function (data, success, error) {
            return query('/course/preview-course', "GET", data, 1, success, error);
        },
        list: function (data, success, error, noloader) {
            return query('/course/list', "GET", data, 1, success, error, true, noloader);
        },
        post: function (data, success, error) {
            return mediaQuery('/course/', "POST", data, 1, success, error);
        },
        tracker: function (data, success, error, noloader) {
            return query('/course/tracker', "POST", data, 1, success, error, true, noloader);
        },
        // patch: function (id, data, success, error) {
        //     return mediaQuery('/course/', "POST", data, 1, success, error);
        // },
        language: function (data, success, error) {
            return query('/course/language/', "GET", data, 1, success, error);
        },
        checkCurriculum: function(data,success,error){
            return query('/course/check-curriculum/', "GET", data, 1, success, error);
        },
        setting: function (data, success, error) {
            return query('/course/settings', "GET", data, 1, success, error);
        },
        courseStatus: function (data, success, error) {
            return query('/course/course-status', "GET", data, 1, success, error);
        },
        createMeeting: function (data, success, error) {
            return query('/course/create-meeting', "POST", data, 1, success, error)
        },
        createQuestion: function (data, success, error) {
            return mediaQuery('/course/create-lecture-question', "POST", data, 1, success, error)
        },
        lectureQuestion: function (data, success, error) {
            return query('/course/lecture-questions', "GET", data, 1, success, error)
        },
        updateQuestion: function (data, success, error) {
            return mediaQuery('/course/update/lecture/question', "PATCH", data, 1, success, error)
        },
        deleteQuestion: function (id, lId, data, success, error) {
            return query('/course/lecture-questions/'+id+'/'+lId, "DELETE", data, 1, success, error)
        },
        deleteQuestionOption: function (id, data, success, error) {
            return query('/course/lecture-questions/'+id, "DELETE", data, 1, success, error)
        },
    },
    courseId: {
        patch: function (id, data, success, error) {
            return mediaQuery('/course/' + id, "PATCH", data, 1, success, error)
        },
    },

    analytic: {
        get : function (data, success, error, noloader) {
            return query('/analytic/', "GET", data, 1, success, error, true, noloader);
        },
        list : function (data, success, error) {
            return query('/analytic/list', "GET", data, 1, success, error);
        },
        courseDetail : function (data, success, error) {
            return query('/analytic/course-detail', "GET", data, 1, success, error);
        },
        studentList : function (data, success, error, noloader) {
            return query('/analytic/student-list', "GET", data, 1, success, error, true, noloader);
        },
        courseGraph : function(data, success, error){
            return query('/analytic/course-graph', 'GET', data, 1, success, error);
        },
        lectureList : function (data, success, error, noloader) {
            return query('/analytic/lecture-list', "GET", data, 1, success, error, true, noloader);
        },
        studentQuizResult : function (data, success, error, noloader) {
            return query('/analytic/student-quiz-result', "GET", data, 1, success, error, true, noloader);
        },
        resend : function (data, success, error, noloader) {
            return query('/analytic/student-failure-reminder', "POST", data, 1, success, error, true, noloader);
        },
        showtotalcount : function(data, success, error){
            return query('/analytic/showtotalcount', 'GET', data, 1, success, error);
        },
        userTrackingList: function(data, success, error, noloader){
            return query('/analytic/userTrackingList/', "GET", data, 1, success, error, true, noloader)
        },
    },
    skill: {
        all: function (data, success, error) {
            return query('/skill/', "GET", data, 1, success, error)
        },
        skillsByParent: function (data, success, error) {
            return query('/skill/skillsByParent/', "GET", data, 1, success, error)
        },
        get: function (id, data, success, error) {
            return query('/skill/all/' + id, "GET", data, 1, success, error)
        },
        add: function (data, success, error) {
            return query('/skill/', "POST", data, 1, success, error)
        },
        update: function (data, success, error) {
            return query('/skill/', "PATCH", data, 1, success, error)
        },
        delete: function (id, data, success, error) {
            return query('/skill/' + id, "DELETE", data, 1, success, error)
        },
    },

    section: {
        get: function (data, success, error) {
            return query('/course/section/', "GET", data, 1, success, error);
        },
        delete: function (data, success, error) {
            return query('/course/delete-section/', "DELETE", data, 1, success, error);
        },
        deleteLecture: function (data, success, error) {
            return query('/course/delete-lecture/', "DELETE", data, 1, success, error);
        },
        post: function (data, success, error) {
            return query('/course/section/', "POST", data, 1, success, error);
        },
        patch: function (data, success, error) {
            return query('/course/section/', "PATCH", data, 1, success, error);
        },
        createLecture: function (data, success, error) {
            return query('/course/section/lecture/', "POST", data, 1, success, error);
        },
        updateLecture: function (data, success, error) {
            return query('/course/section/updatelecture/', "PATCH", data, 1, success, error);
        },
        uploadLectureFile: function (data, success, error) {
            return queryURL('/course/upload-lecture-file/', "POST", data, 1, success, error );
        },
    },

    quiz: {
        get: function (data, success, error) {
            return query('/quiz/', "GET", data, 1, success, error);
        },
        clone: function (data, success, error) {
            return query('/quiz/clone', "GET", data, 1, success, error);
        },
        list: function (data, success, error,noloader) {
            return query('/quiz/list', "GET", data, 1, success, error,true,noloader);
        },
        post: function (data, success, error) {
            return mediaQuery('/quiz/', "POST", data, 1, success, error);
        },
        update: function (data, success, error) {
            return mediaQuery('/quiz/', "PATCH", data, 1, success, error);
        },
        createQuestion: function (data, success, error) {
            return mediaQuery('/quiz/question', "POST", data, 1, success, error);
        },
        editQuestion: function (data, success, error) {
            return mediaQuery('/quiz/question', "PATCH", data, 1, success, error);
        },
        deleteQuestion: function (data, success, error) {
            return query('/quiz/delete', "DELETE", data, 1, success, error);
        },
        deleteQuestionOption: function (data, success, error) {
            return query('/quiz/delete-option', "DELETE", data, 1, success, error);
        },
        settings: function(data, success, error){
            return query('/quiz/settings',"GET", data, 1, success, error);
        },
        isQuestionAdded: function(data, success, error){
            return query('/quiz/question-count',"GET", data, 1, success, error);
        },
        guidelines: function(id, skey, data, success, error, noloader){
            return query('/quiz/guidelines/'+id+'/'+skey, "GET", data, 1, success, error, true, noloader)
        },
    },
    iam: {
        policylist: function (data, tableId, column_data) {
            return dataQuery('/iam/list/', "GET", data, tableId, column_data)
        },
        userRolelist: function (data, tableId, column_data) {
            return dataQuery('/iam/userRoleList/', "GET", data, tableId, column_data)
        },
        userRoleCount: function (data, success, error) {
            return query('/iam/userRoleCount/', "GET", data, 1, success, error)
        },

        showPolicy: function (id, data, success, error) {
            return query('/iam/show/' + id, "GET", data, 1, success, error)
        },
        searchlist: function (data, success, error) {
            return query('/iam/search/', "POST", data, 1, success, error)
        },
        searchaction: function (data, success, error) {
            return query('/iam/searchAction/', "POST", data, 1, success, error)
        },
        createPolicy: function (data, success, error) {
            return query('/iam/add/', "POST", data, 1, success, error)
        },
        updatePolicy: function (data, success, error) {
            return query('/iam/update/', "patch", data, 1, success, error)
        },
        policyDelete: function (id, data, success, error) {
            return query('/iam/delete/' + id, "GET", data, 1, success, error)
        },
        policyUserCount: function (id, data, success, error) {
            return query('/iam/count/' + id, "GET", data, 1, success, error)
        },
        createUsersRoles: function (data, success, error) {
            return query('/iam/addUserRoles', "POST", data, 1, success, error)
        },
        
    },
    iamUser:{
        Userlist: function(data,tableId,column_data){
            return dataQuery('/iam-user/list/', "GET", data,tableId,column_data)
        },
        UserPolicylist: function(id,tableId,column_data){
            return dataQuery('/iam-user/show/'+id, "GET", id,tableId,column_data)
        },
        employeeDelete: function(id,data,success,error){
            return query('/iam-user/delete/'+id,'DELETE',data,1,success,error)
        },
        UserpolicyDelete: function(policyId,data,success,error){
            return query('/iam-user/delete/'+policyId,'GET',data,1,success,error)
        },
        addEmployee: function(data,success,error){
            return query('/iam-user/addEmployee/','POST',data,1,success,error)
        },
        employeePolicyList: function(id,tableId,column_data){
            return dataQuery('/iam-user/employeePolicyList/'+id,'GET',id,tableId,column_data)
        },
        employeePolicyUpdate: function(id,data,success,error){
            return query('/iam-user/employeePolicyUpdate/'+id,'PATCH',data,1,success,error)
        },
        employeeResetPassword: function(data, success, error){
            return query('/iam-user/resetPassword/', 'POST',data,1, success, error)
        },
    },
    action: {
        actionlist: function (data, tableId, column_data) {
            return dataQuery('/action/actionlist/' + data, "GET", data, tableId, column_data)
        },
    },
    company: {
        get: function(data, success, error, showError){
            return query('/company/', "GET", data, 1, success, error, showError)
        },
        switchProfile: function(data, success, error, showError){
            return query('/company/switchProfile', "GET", data, 1, success, error, showError)
        },
        smtp: function(data, success, error, showError){
            return query('/company/set-smtp-type', "GET", data, 1, success, error, showError)
        },
        skipLogin: function(data, success, error, showError){
            return query('/company/skip-login', "GET", data, 1, success, error, showError)
        },
    },
    campaign: {
        result: function (data, success, error) {
            return query('/campaign/result', "GET", data, 1, success, error);
        },
        resultCount: function (data, success, error) {
            return query('/campaign/resultCount', "GET", data, 1, success, error);
        },
        list: function (data, success, error) {
            return query('/campaign/list', "GET", data, 1, success, error);
        },
        courseList: function (data, success, error) {
            return query('/campaign/course-list', "GET", data, 1, success, error);
        },
        quizList: function (data, success, error) {
            return query('/campaign/quiz-list', "GET", data, 1, success, error);
        },
        post: function(data,success,error){
            return query('/simulation/',"POST",data, 1, success, error);
        },
        delete: function(data, success, error){
            return query('/campaign/', "DELETE", data, 1, success, error)
        },
        fetcherrordetails:function (id,data, success, error) {
            return query('/campaign/fetch-error/'+id, "GET", data, 1, success, error);
        },
    },
    simulation: {
        post: function(id, data, success, error){
            return query('/simulation/'+id, "POST", data, 1, success, error)
        }
    },
    campaignId: {
        delete: function(id, data, success, error){
            return query('/campaign/'+id+'/', "DELETE", data, 1, success, error)
        }
    },
    learner: {
        courseList: function(data, success, error, noloader){
            return query('/learner/list/', "GET", data, 1, success, error, true, noloader)
        },
        quizList: function(data, success, error, noloader){
            return query('/learner/quiz/list/', "GET", data, 1, success, error, true, noloader)
        },
        onGoingCourse: function(data, success, error){
            return query('/learner/list/ongoing/', "GET", data, 1, success, error)
        },
        downloadCertificate: function(data, success, error){
            return query('/learner/list/download-certificate/', "GET", data, 1, success, error)
        },
        startquiz: function(data, success, error){
            return query('/learner/startquiz/', "GET", data, 1, success, error)
        },
        nextQuestion: function(data, success, error){
            return query('/learner/startQuizQuestion/', "GET", data, 1, success, error)
        },
        saveAnswer: function(data, success, error){
            return query('/learner/saveAnswer/', "GET", data, 1, success, error)
        }, 
        finishTest: function(data, success, error){
            return query('/learner/finishTest/', "GET", data, 1, success, error)
        },
        submitTest: function(data, success, error){
            return query('/learner/submitTest/', "GET", data, 1, success, error)
        },
        resetQuiz: function(data, success, error){
            return query('/learner/resetQuiz/', "GET", data, 1, success, error)
        },
        quizResult: function(data, success, error){
            return query('/learner/quizResult/', "GET", data, 1, success, error)
        },
        courseQuizResult: function (data, success, error, noloader) {
            return query('/learner/course-quiz-result', "GET", data, 1, success, error, true, noloader);
        },
    },
    setting: {
        AD: function(data, success, error){
            return query('/group/active/directory', "POST", data, 1, success, error)
        },
        profileUpdate: function(data, success, error){
            return query('/auth/profile/', "PATCH", data, 1, success, error)
        },
        update: function(id, data, success, error, showError){
            return mediaQuery('/company/'+id, "PATCH", data, 1, success, error, showError)
        },
        changePassword: function (data, success, error) {
            return query('/auth/changePassword/', "POST", data, 1, success, error)
        },
    },
    result: {
        list: function(data, success, error, noloader){
            return query('/result/', "GET", data, 1, success, error, true, noloader)
        },
        get: function(data, success, error, noloader){
            return query('/result/user-list', "GET", data, 1, success, error, true, noloader)
        },
    },
    billing: {
        fetch: function(data, success, error, noloader){
            return query('/appsumo/', "GET", data, 1, success, error, true, noloader)
        },
        check: function(data, success, error, noloader){
            return query('/appsumo/check', "GET", data, 1, success, error, true, noloader)
        },
        redeem: function(data, success, error, noloader){
            return query('/appsumo/redeem', "GET", data, 1, success, error, true, noloader)
        },
    },
    sender: {
        get: function(data, success, error){
            return query('/sender/', "GET", data, 1, success, error, true)
        },
        post:function(data, success, error){
            return query('/sender/', "POST", data, 1, success, error, true)
        },
        send:function(data, success, error){
            return query('/sender/testEmail', "POST", data, 1, success, error, true)
        },
        patch: function(id, data, success, error){
            return query('/sender/'+id, "PATCH", data, 1, success, error, true)
        },
        advancedSettings: function(id, data, success, error){
            return query('/sender/advanced/'+id, "PATCH", data, 1, success, error, true)
        },
    },
    header: {
        get: function(data, success, error){
            return query('/sender/headers/', "GET", data, 1, success, error, true)
        },
        post:function(data, success, error){
            return query('/sender/headers/', "POST", data, 1, success, error, true)
        },
        delete: function(id, data, success, error){
            return query('/sender/header/'+id, "DELETE", data, 1, success, error, true)
        }
    },

    unsubscribe: {
        post:function(data, success, error){
            return query('/member/unsubscribe/', "POST", data, 1, success, error, true)
        },
    },
    template: {
        list: function(data, success, error, noloader){
            return query('/template/', "GET", data, 1, success, error, true, noloader)
        },
        post: function(data, success, error){
            return mediaQuery('/template/', "POST", data, 1, success, error)
        },
        get: function(data, success, error, noloader){
            return query('/template/edit', "GET", data, 1, success, error, true, noloader)
        },
        change: function(data, success, error, noloader){
            return query('/template/change', "GET", data, 1, success, error, true, noloader)
        },
        changeTextOrImage: function(data, success, error, noloader){
            return query('/template/change-text-image', "GET", data, 1, success, error, true, noloader)
        },
        
    },
}