import express from 'express';
import { authRouter } from './resources/modules/auth';
import { homeRouter } from './resources/modules/home';
import { courseRouter } from './resources/modules/course';
import { groupRouter } from './resources/modules/group';
import { skillRouter } from './resources/modules/skill';
import { campaignRouter } from './resources/modules/campaign';
import { quizRouter } from './resources/modules/quiz';
import { courseanalyticRouter } from './resources/modules/courseanalytic';
import { discussionboardRouter } from './resources/modules/discussionboard';
import { learnerRouter } from './resources/modules/learner';
import { policyRouter } from './resources/modules/policy';
import { iamUserRouter } from './resources/modules/iam-user';
import { settingsRouter } from './resources/modules/settings';
import { trackerRouter } from './resources/modules/tracker';
import { resultRouter } from './resources/modules/result';
import { appsumoRouter } from './resources/modules/appsumo';
import { billingRouter } from './resources/modules/billing';
import {emailunsubscribeRouter } from './resources/modules/emailunsubscribe';
import { activityRouter } from './resources/modules/activity';
import { templateRouter } from './resources/modules/template';


export const webRouter = express.Router();
webRouter.use('/', [
    authRouter, 
    homeRouter,
    courseRouter,
    groupRouter,
    skillRouter,
    campaignRouter,
    quizRouter,
    courseanalyticRouter,
    discussionboardRouter,
    learnerRouter,
    policyRouter,
    iamUserRouter ,
    settingsRouter,
    trackerRouter,
    resultRouter,
    appsumoRouter,
    billingRouter,
    emailunsubscribeRouter,
    activityRouter,
    templateRouter
]);