import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import campaignController from './campaign.controller';
import { userPermission} from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const campaignRouter = express.Router();
campaignRouter.route('/campaign/list').get(jwtStrategy , userImplant , userPermission('campaign-list'), campaignController.index);
campaignRouter.route('/campaign/:id').get(jwtStrategy , userImplant ,userPermission('campaign-result-s1'), campaignController.campaign);