import { db } from "../../../../models";

export default {
    async index(req, res, next) {
        if(req.query && Object.keys(req.query).length == 2 && req.query.unsubscribe_code && req.query.mId){
            if(req.query.mId == 'RXertMZt' || req.query.mId == 'MXertRZt'){
                db.Member.findOne({  attributes:['email', 'courseMails', 'assessmentMails', 'reminderMails', 'announcementMails'], where : { code: req.query.unsubscribe_code}})
                .then(member => {
                    if(member){
                        return res.render('emailunsubscribe', {
                            layout: 'auth', 
                            code:req.query.unsubscribe_code, 
                            success: (req.query.mId == 'RXertMZt' ? false: true),
                            email: member.email,
                            courseMails: member.courseMails,
                            assessmentMails: member.assessmentMails,
                            reminderMails: member.reminderMails,
                            announcementMails: member.announcementMails
                        });
                    }else res.status(500).send('Invalid user received.!');
                })
            }else res.status(500).send('Invalid data received.!');
        }else res.status(500).send('Invalid data received.!');
    }
};