import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import groupController from './group.controller';
import { userPermission} from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const groupRouter = express.Router();
groupRouter.route('/department/list').get(jwtStrategy , userImplant, userPermission('group-departments-list'),groupController.index);
groupRouter.route('/department/:id').get(jwtStrategy, userImplant, userPermission('group-departments-read'),groupController.department);

